(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('@angular/router'), require('@angular/common'), require('util'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('ag-table', ['exports', '@angular/core', '@angular/forms', '@angular/router', '@angular/common', 'util', 'rxjs', 'rxjs/operators'], factory) :
    (global = global || self, factory(global['ag-table'] = {}, global.ng.core, global.ng.forms, global.ng.router, global.ng.common, global.util, global.rxjs, global.rxjs.operators));
}(this, (function (exports, core, forms, router, common, util, rxjs, operators) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var TRANSLATION = {};

    var TRANSLATION$1 = {
        TITULO: {
            ptBR: 'TITULO'
        }
    };


    (function (AgTableFilterMode) {
        AgTableFilterMode["CONTAINS"] = "contains";
        AgTableFilterMode["EQUALS"] = "equals";
        AgTableFilterMode["STARTS_WITH"] = "startsWith";
        AgTableFilterMode["ENDS_WITH"] = "endsWith";
    })(exports.AgTableFilterMode || (exports.AgTableFilterMode = {}));

    var TRANSLATION$2 = {
        ALL_OPTION: {
            ptBR: 'Todos',
            enUS: 'All'
        },
        DATE_FORMAT: {
            ptBR: 'dd/MM/yyyy',
            enUS: 'yyyy/MM/dd'
        }
    };


    (function (AgTableFilterType) {
        AgTableFilterType["NONE"] = "none";
        AgTableFilterType["TEXT"] = "text";
        AgTableFilterType["SELECT"] = "select";
        AgTableFilterType["DATE"] = "date";
        AgTableFilterType["CURRENCY"] = "currency";
        // NUMBER = 'number',
    })(exports.AgTableFilterType || (exports.AgTableFilterType = {}));

    var Helper = /** @class */ (function () {
        function Helper() {
            this.datePipe = new common.DatePipe('en-US');
        }
        Helper.prototype.padLeft = function (text, qtty, char) {
            if (qtty === void 0) { qtty = 2; }
            if (char === void 0) { char = 0; }
            if (!util.isNullOrUndefined(text))
                while (text.length < qtty)
                    text = char + text;
            return text;
        };
        Helper.prototype.padRight = function (text, qtty, char) {
            if (qtty === void 0) { qtty = 2; }
            if (char === void 0) { char = 0; }
            if (!util.isNullOrUndefined(text))
                while (text.length < qtty)
                    text += char;
            return text;
        };
        Helper.prototype.randomNumber = function (min, max) {
            if (min === void 0) { min = 1; }
            if (max === void 0) { max = 9999; }
            var number = Math.floor(Math.random() * max);
            return Math.max(number, min);
        };
        Helper.prototype.onlyNumbers = function (text, exceptions) {
            if (exceptions === void 0) { exceptions = null; }
            if (!util.isNullOrUndefined(text)) {
                var expression = (exceptions && exceptions.length) ? ('[^\\d|' + exceptions.join('|') + ']') : '[^\\d]';
                return text.replace(new RegExp(expression, 'g'), '');
            }
            return '';
        };
        Helper.prototype.onlyAlphaNumeric = function (text) {
            if (!util.isNullOrUndefined(text))
                return text.replace(/[^a-zA-Z0-9]+/g, '');
            return '';
        };
        Helper.prototype.onlyNumberAndToFloat = function (text) {
            if (text) {
                var strNumber = text.replace(/[^\d.\d]/g, '');
                var number = parseFloat(strNumber);
                if (!isNaN(number))
                    return number;
            }
            return 0;
        };
        Helper.prototype.removeAccents = function (text) {
            return text ? text.normalize('NFD').replace(/[\u0300-\u036f]/g, '') : '';
        };
        Helper.prototype.dateIsValid = function (date, dateFormat) {
            return !util.isNullOrUndefined(this.strToDate(date, dateFormat));
        };
        Helper.prototype.toAmericanDate = function (date, separator) {
            if (separator === void 0) { separator = '-'; }
            if (date instanceof Date)
                date = this.dateToStr(date);
            if (this.dateIsValid(date)) {
                var dateStr = date;
                if (dateStr && (dateStr.includes('-') || dateStr.includes('/'))) {
                    if (dateStr.includes('/'))
                        dateStr = dateStr.replace(/\//g, '-');
                    var dateSplited = dateStr.split('-');
                    if (dateSplited.length >= 3) {
                        var year = parseInt((dateSplited[0].length === 4) ? dateSplited[0] : dateSplited[2]);
                        var month = parseInt(dateSplited[1]);
                        var day = parseInt((dateSplited[0].length === 4) ? dateSplited[2] : dateSplited[0]);
                        var arrayDate = [year, (month > 9 ? month : ('0' + month)), (day > 9 ? day : ('0' + day))];
                        return arrayDate.join(separator);
                    }
                }
            }
            return date;
        };
        Helper.prototype.strToDate = function (date, dateFormat) {
            var e_1, _a;
            if (typeof date === 'string' && (date.length >= 8 || dateFormat)) {
                var dateStr = date;
                if (dateStr && (dateStr.includes('-') || dateStr.includes('/'))) {
                    if (dateStr.includes('/'))
                        dateStr = dateStr.replace(/\//g, '-');
                    dateStr = dateStr.substr(0, 10);
                    if (dateFormat)
                        dateFormat = dateFormat.replace(/\//g, '-');
                    var dateSplited = dateStr.split('-');
                    var length_1 = dateSplited.length;
                    if (length_1 >= 1) {
                        var year = 1111;
                        var month = 11;
                        var day = 11;
                        if (length_1 >= 3) {
                            year = parseInt((dateSplited[0].length === 4) ? dateSplited[0] : dateSplited[2]);
                            month = parseInt(dateSplited[1]);
                            day = parseInt((dateSplited[0].length === 4) ? dateSplited[2] : dateSplited[0]);
                        }
                        else if (dateFormat) {
                            var i = 0;
                            try {
                                for (var _b = __values(dateFormat.split('-')), _c = _b.next(); !_c.done; _c = _b.next()) {
                                    var format = _c.value;
                                    try {
                                        if (format.toLowerCase().startsWith('y'))
                                            year = parseInt(dateSplited[i]);
                                        else if (format.toLowerCase().startsWith('m'))
                                            month = parseInt(dateSplited[i]);
                                        else if (format.toLowerCase().startsWith('d'))
                                            day = parseInt(dateSplited[i]);
                                    }
                                    catch (_d) { }
                                    i++;
                                }
                            }
                            catch (e_1_1) { e_1 = { error: e_1_1 }; }
                            finally {
                                try {
                                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                                }
                                finally { if (e_1) throw e_1.error; }
                            }
                        }
                        var arrayDate = [year, (month > 9 ? month : ('0' + month)), (day > 9 ? day : ('0' + day))];
                        dateStr = arrayDate.join('-');
                        if (dateStr)
                            return new Date(year, month - 1, day, 0, 0, 0);
                    }
                }
            }
            else if (date instanceof Date)
                return date;
            return null;
        };
        Helper.prototype.setDaysToDate = function (date, days) {
            if (typeof date === 'string')
                date = this.strToDate(date);
            else if (date)
                date = this.copyDate(date);
            if (date && typeof days === 'number')
                return new Date(date.setDate(date.getDate() + days));
            return date;
        };
        Helper.prototype.dateToStr = function (date, format) {
            if (format === void 0) { format = 'dd/MM/yyyy'; }
            if (!format)
                format = 'dd/MM/yyyy';
            format = format.replace(/mm/g, 'MM');
            if (date) {
                if (typeof date === 'string')
                    date = this.strToDate(date);
                return this.datePipe.transform(date, format);
            }
            return null;
        };
        Helper.prototype.getDateToday = function (withHours) {
            if (withHours === void 0) { withHours = false; }
            var today = new Date();
            if (withHours)
                return today;
            else
                return new Date(today.getFullYear(), today.getMonth(), today.getDate(), 0, 0, 0);
        };
        Helper.prototype.getYearOfDate = function (date) {
            date = this.strToDate(date);
            if (date)
                return date.getFullYear();
            return 0;
        };
        Helper.prototype.getMonthOfDate = function (date) {
            date = this.strToDate(date);
            if (date)
                return date.getMonth() + 1;
            return 0;
        };
        Helper.prototype.getDayOfDate = function (date) {
            date = this.strToDate(date);
            if (date)
                return date.getDate();
            return 0;
        };
        Helper.prototype.copyDate = function (date) {
            if (date)
                return new Date(date.toString());
            return date;
        };
        Helper.prototype.dateFormat = function (date, format) {
            if (format === void 0) { format = 'dd/MM/yyyy'; }
            date = this.strToDate(date);
            if (date)
                return this.datePipe.transform(date, format);
            return null;
        };
        Helper.prototype.strToDoubleCurrency = function (strCurrency) {
            strCurrency = strCurrency.replace(/[,.]/g, function (m) { return m === ',' ? '.' : ','; });
            return Number(strCurrency);
        };
        Helper.prototype.copy = function (obj) {
            if (obj)
                return JSON.parse(JSON.stringify(obj));
            else
                return obj;
        };
        Helper.prototype.copyToClipboard = function (inputElement) {
            inputElement.focus();
            inputElement.select();
            var successful = document.execCommand('copy');
        };
        Helper.prototype.getDiffOfDate = function (dateBegin, dateEnd, returnType) {
            if (returnType === void 0) { returnType = 'days'; }
            if (dateBegin && dateEnd) {
                var delta = Math.abs(dateEnd.getTime() - dateBegin.getTime()) / 1000;
                var days = Math.floor(delta / 86400);
                delta -= days * 86400;
                var hours = Math.floor(delta / 3600) % 24;
                delta -= hours * 3600;
                var minutes = Math.floor(delta / 60) % 60;
                delta -= minutes * 60;
                var seconds = Math.floor(delta % 60);
                if (returnType === 'days')
                    return days;
                else if (returnType === 'hours')
                    return hours;
                else if (returnType === 'minutes')
                    return minutes;
                else if (returnType === 'seconds')
                    return seconds;
            }
            return 0;
        };
        Helper.prototype.stringReplace = function (source, str, strToRep) {
            return source.replace(str, strToRep).toString();
        };
        Helper = __decorate([
            core.Injectable()
        ], Helper);
        return Helper;
    }());

    var AgTableSettingsAbstract = /** @class */ (function () {
        function AgTableSettingsAbstract() {
            this.lang = 'en-US';
            this.filterDebounceTime = 500;
        }
        return AgTableSettingsAbstract;
    }());

    var AgTableCustomSettings = /** @class */ (function (_super) {
        __extends(AgTableCustomSettings, _super);
        function AgTableCustomSettings() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AgTableCustomSettings.ɵprov = core.ɵɵdefineInjectable({ factory: function AgTableCustomSettings_Factory() { return new AgTableCustomSettings(); }, token: AgTableCustomSettings, providedIn: "root" });
        AgTableCustomSettings = __decorate([
            core.Injectable({
                providedIn: 'root'
            })
        ], AgTableCustomSettings);
        return AgTableCustomSettings;
    }(AgTableSettingsAbstract));

    var AgTableSettings = /** @class */ (function (_super) {
        __extends(AgTableSettings, _super);
        function AgTableSettings(customSettings) {
            var _this = _super.call(this) || this;
            if (customSettings)
                Object.assign(_this, customSettings);
            return _this;
        }
        AgTableSettings.ctorParameters = function () { return [
            { type: AgTableCustomSettings }
        ]; };
        AgTableSettings.ɵprov = core.ɵɵdefineInjectable({ factory: function AgTableSettings_Factory() { return new AgTableSettings(core.ɵɵinject(AgTableCustomSettings)); }, token: AgTableSettings, providedIn: "root" });
        AgTableSettings = __decorate([
            core.Injectable({
                providedIn: 'root'
            })
        ], AgTableSettings);
        return AgTableSettings;
    }(AgTableSettingsAbstract));

    var AgTableLangService = /** @class */ (function () {
        function AgTableLangService(settings) {
            this.settings = settings;
        }
        Object.defineProperty(AgTableLangService.prototype, "lang", {
            get: function () { return this.settings.lang; },
            set: function (value) { this.settings.lang = value; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AgTableLangService.prototype, "langTranslation", {
            get: function () { return this.lang.replace(/-/g, '').trim(); },
            enumerable: true,
            configurable: true
        });
        AgTableLangService.prototype.setLang = function (lang, reloadPage) {
            if (reloadPage === void 0) { reloadPage = false; }
            this.lang = lang;
            if (reloadPage)
                location.reload();
        };
        AgTableLangService.prototype.getLang = function () { return this.lang; };
        AgTableLangService.prototype.getText = function (value, dict, asString) {
            var _this = this;
            if (asString === void 0) { asString = true; }
            var getText = function (arg) {
                var observ = arg ? arg : null;
                if (!dict || JSON.stringify(dict) !== '{}') {
                    var helper = _this.processValue(value, dict);
                    // tslint:disable-next-line:quotemark
                    if (typeof helper === "object") {
                        var text = "-- WITHOUT TRANSLATION [" + value + "] --";
                        if (observ)
                            observ.next(text);
                        else
                            return text;
                    }
                    else {
                        if (observ)
                            observ.next(helper);
                        else
                            return helper;
                    }
                }
                else {
                    if (observ) {
                        if (dict && value in dict && _this.langTranslation in dict[value])
                            observ.next(dict[value][_this.langTranslation]);
                        else
                            observ.next('');
                    }
                    else {
                        if (dict && value in dict && _this.langTranslation in dict[value])
                            return dict[value][_this.langTranslation];
                        else
                            return '';
                    }
                }
                if (observ)
                    return function () { return observ.unsubscribe(); };
            };
            if (!asString)
                return new rxjs.Observable(getText);
            else
                return getText();
        };
        AgTableLangService.prototype.processValue = function (prop, dict) {
            var e_1, _a;
            var positions = prop.split('.');
            var helper = null;
            if (dict && JSON.stringify(dict) !== '{}') {
                helper = dict;
                try {
                    for (var positions_1 = __values(positions), positions_1_1 = positions_1.next(); !positions_1_1.done; positions_1_1 = positions_1.next()) {
                        var _prop = positions_1_1.value;
                        if (_prop in helper)
                            helper = helper[_prop];
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (positions_1_1 && !positions_1_1.done && (_a = positions_1.return)) _a.call(positions_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
                if (this.langTranslation in helper)
                    helper = helper[this.langTranslation];
            }
            return helper ? helper : '';
        };
        AgTableLangService.ctorParameters = function () { return [
            { type: AgTableSettings }
        ]; };
        AgTableLangService.ɵprov = core.ɵɵdefineInjectable({ factory: function AgTableLangService_Factory() { return new AgTableLangService(core.ɵɵinject(AgTableSettings)); }, token: AgTableLangService, providedIn: "root" });
        AgTableLangService = __decorate([
            core.Injectable({
                providedIn: 'root'
            })
        ], AgTableLangService);
        return AgTableLangService;
    }());

    var AgTableColComponent = /** @class */ (function () {
        function AgTableColComponent(helper, langService, fb, elRef) {
            this.helper = helper;
            this.langService = langService;
            this.fb = fb;
            this.elRef = elRef;
            this._class = true;
            this.width = null;
            this.filter = exports.AgTableFilterType.NONE;
            this.field = '';
            this.mode = null;
            this.placeholder = '';
            this.dateFormat = '';
            this.optionAllLabel = '';
            this.options = [];
            /* DISABLED
            @Input('ready-only') public readOnly: boolean = false;
            @Input('min-date') public minDate: Date;
            @Input('max-date') public maxDate: Date;
            @Input('date-separator') public dateSeparator: string = '/'; */
            this.noSort = false;
            this.noTruncate = false;
            this.sort = null;
            this.disableFilter = false;
            this.filterValue = null;
            this.dictionary = TRANSLATION$2;
            this.colIndex = 0;
            this.canFiltering = false;
            this.fields = [];
            this.filterActive = false;
        }
        Object.defineProperty(AgTableColComponent.prototype, "_width", {
            get: function () { return (this.elRef && this.el) ? this.el.style.width : 'auto'; },
            set: function (value) {
                if (this.el) {
                    this.el.style.width = value;
                    if (value && value.endsWith('%'))
                        this.el.style.maxWidth = ((this.helper.onlyNumberAndToFloat(value) * this.parent.el.clientWidth) / 100) + 'px';
                    else
                        this.el.style.maxWidth = value;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AgTableColComponent.prototype, "el", {
            get: function () { return (this.elRef && this.elRef.nativeElement) ? this.elRef.nativeElement : null; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AgTableColComponent.prototype, "canFilter", {
            get: function () {
                return (this.filter && this.filter !== exports.AgTableFilterType.NONE && this.filter.toString() !== '') ||
                    (this.customFilter && this.customFilter.length > 0);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AgTableColComponent.prototype, "isSorting", {
            get: function () { return this.parent && this.parent.colSorting && this.parent.colSorting.col === this; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AgTableColComponent.prototype, "isSortAsc", {
            get: function () { return this.isSorting && this.parent.colSorting.asc; },
            enumerable: true,
            configurable: true
        });
        AgTableColComponent.prototype.ngOnInit = function () {
        };
        AgTableColComponent.prototype.ngAfterViewInit = function () {
            if (!this.optionAllLabel)
                this.optionAllLabel = this.langService.getText('ALL_OPTION', this.dictionary);
            if (!this.dateFormat)
                this.dateFormat = this.langService.getText('DATE_FORMAT', this.dictionary);
            if (!this.noSort && !this.field && (!this.customFilter || !this.customFilter.length)) {
                this.filter = exports.AgTableFilterType.NONE;
                console.warn("The ordering will not applied because the [field] of column has not been defined.");
            }
        };
        AgTableColComponent.prototype.ngOnChanges = function (changes) {
            var _this = this;
            if (!changes || 'width' in changes) {
                if (!this.widthIsValid())
                    this.width = 'auto';
                if (this.widthIsValid() && this.helper.onlyNumbers(this.width) === this.width)
                    this.width += 'px';
                if (this.parent && this.parent.cols) {
                    var unit_1 = this.getWidthUnit();
                    if (unit_1 !== '' && this.parent.cols.some(function (x) { return x.getWidthUnit() !== '' && x.getWidthUnit() !== unit_1; })) {
                        var anotherUnit = this.parent.cols.find(function (x) { return x.getWidthUnit() !== '' && x.getWidthUnit() !== unit_1; }).getWidthUnit();
                        console.warn("A another column has width defined with like \"" + anotherUnit + "\". So this [width] was redefined as \"auto\".");
                        this.width = 'auto';
                        this.setWidth();
                        return;
                    }
                }
                if (this.getWidthUnit() === '%') {
                    if (parseFloat(this.width.replace(this.getWidthUnit(), '')) >= 100) {
                        console.warn("The columns cannot have width equal or greater than 100%.");
                        this.width = 'auto';
                        this.setWidth();
                        return;
                    }
                }
                this.setWidth();
            }
            if (changes) {
                if ('noSort' in changes)
                    this.noSort = (typeof this.noSort === 'string' && (this.noSort === '' || this.noSort === 'true')) ? true : this.noSort;
                if ('noTruncate' in changes)
                    this.noTruncate = (typeof this.noTruncate === 'string' && (this.noTruncate === '' || this.noTruncate === 'true')) ? true : this.noTruncate;
                if ('sort' in changes) {
                    this.sort = !this.sort ? null : this.sort;
                    if (this.sort !== 'asc' && this.sort !== 'desc')
                        this.sort = null;
                    if (this.parent) {
                        this.parent.colSorting = {
                            col: this,
                            asc: this.sort === 'asc'
                        };
                        this.sort = null;
                        this.parent.parent.onSortChange();
                    }
                }
                if ('filter' in changes) {
                    if (!this.filter && this.filter.toString() !== '')
                        this.filter = exports.AgTableFilterType.NONE;
                    else if (this.filter.toString() === '')
                        this.filter = exports.AgTableFilterType.TEXT;
                    if (this.filter !== exports.AgTableFilterType.NONE && !this.mode) {
                        switch (this.filter) {
                            case exports.AgTableFilterType.TEXT:
                            case exports.AgTableFilterType.CURRENCY:
                                this.mode = exports.AgTableFilterMode.CONTAINS;
                                break;
                            case exports.AgTableFilterType.SELECT:
                            case exports.AgTableFilterType.DATE:
                                this.mode = exports.AgTableFilterMode.EQUALS;
                                break;
                            default:
                                this.mode = exports.AgTableFilterMode.CONTAINS;
                                break;
                        }
                    }
                    if (this.parent) {
                        if (this.field && this.parent.filterCtrls[this.field]) {
                            if (this.disableFilter)
                                this.parent.filterCtrls[this.field].disable();
                            else
                                this.parent.filterCtrls[this.field].enable();
                        }
                        else if (this.customFilter)
                            this.customFilter.forEach(function (custom) {
                                if (_this.disableFilter)
                                    _this.parent.filterCtrls[custom.field].disable();
                                else
                                    _this.parent.filterCtrls[custom.field].enable();
                            });
                    }
                    if (this.canFilter && !this.field) {
                        this.filter = exports.AgTableFilterType.NONE;
                        console.warn("The filter will not applied because the [field] of column has not been defined.");
                    }
                    setTimeout(function () {
                        if (_this.parent)
                            _this.parent.parent.definePaddingTop();
                    });
                }
                if ('customFilter' in changes) {
                    if (this.canFilter && this.field) {
                        console.warn("The [custom-filter] will not applied because the [filter] has already been defined.");
                        this.customFilter = null;
                        return;
                    }
                    else {
                        if (this.customFilter && (util.isObject(this.customFilter) || typeof this.customFilter === 'string')) {
                            if (util.isObject(this.customFilter) && !util.isArray(this.customFilter))
                                this.customFilter = [this.customFilter];
                            else if (util.isArray(this.customFilter) && (this.customFilter.length > 0 && typeof this.customFilter[0] === 'string'))
                                this.customFilter = this.customFilter.map(function (field) { return ({ field: field }); });
                            else if (!util.isObject(this.customFilter))
                                this.customFilter = [{ field: this.customFilter }];
                            if (!util.isArray(this.customFilter) || !this.customFilter.every(function (x) { return (util.isObject(x) && x.field) ? true : false; })) {
                                console.warn("The [custom-filter] will not applied because field has not been informed or is invalid. The value should look like this: { field: string, mode?: string }");
                                this.customFilter = null;
                            }
                            else {
                                if (!this.noSort)
                                    this.noSort = this.customFilter.length > 1;
                                this.customFilter.forEach(function (filter) {
                                    if (!filter.mode)
                                        filter.mode = exports.AgTableFilterMode.CONTAINS;
                                });
                                setTimeout(function () {
                                    if (_this.parent)
                                        _this.parent.parent.definePaddingTop();
                                });
                            }
                        }
                        else {
                            console.warn("The [custom-filter] will not applied because value is invalid. The value should look like this: { field: string, mode?: string }");
                            this.customFilter = null;
                        }
                    }
                }
            }
        };
        AgTableColComponent.prototype.makeFormControl = function (defaultValue) {
            if (defaultValue === void 0) { defaultValue = null; }
            return this.fb.control(defaultValue);
        };
        AgTableColComponent.prototype.onFiltering = function () {
            var _this = this;
            if (this.parent && this.parent.parent) {
                if (this.parent) {
                    if (this.field)
                        this.filterActive = (this.parent.filterCtrls[this.field] && this.parent.filterCtrls[this.field].value !== null && this.parent.filterCtrls[this.field].value !== '');
                    else if (this.customFilter)
                        this.filterActive = this.customFilter.some(function (custom) {
                            return _this.parent.filterCtrls[custom.field] && _this.parent.filterCtrls[custom.field].value !== null && _this.parent.filterCtrls[custom.field].value !== '';
                        });
                }
                else
                    this.filterActive = false;
                this.parent.parent.onFilterChange();
            }
        };
        AgTableColComponent.prototype.onFilterRender = function () {
            if (this.parent)
                this.parent.parent.definePaddingTop();
        };
        AgTableColComponent.prototype.toggleSort = function () {
            if (this.parent && this.parent.parent && !this.parent.parent.loading) {
                var asc = void 0;
                if (this.isSorting) {
                    if (this.parent.colSorting.asc) {
                        asc = false;
                        this.parent.colSorting = {
                            col: this,
                            asc: asc
                        };
                    }
                    else {
                        this.parent.colSorting = null;
                    }
                }
                else {
                    asc = true;
                    this.parent.colSorting = {
                        col: this,
                        asc: asc
                    };
                }
                this.parent.parent.onSortChange();
            }
        };
        AgTableColComponent.prototype.widthIsValid = function () {
            return !util.isNullOrUndefined(this.width) && (typeof this.width === 'string') && this.width !== '' && this.width !== 'auto';
        };
        AgTableColComponent.prototype.getWidthUnit = function () {
            return this.widthIsValid() ? this.width.replace(this.helper.onlyNumbers(this.width), '') : '';
        };
        AgTableColComponent.prototype.onRender = function (parent, index) {
            this.parent = parent;
            this.colIndex = index;
            this.canFiltering = this.canFilter && !util.isNullOrUndefined(this.parent.filterCtrls);
            this.fields = this.generateFieldsFilter();
            this.setWidth();
            this.ngOnChanges(null);
        };
        AgTableColComponent.prototype.generateFieldsFilter = function () {
            if (this.canFilter) {
                if (this.field)
                    return [this.field];
                else
                    return this.customFilter.map(function (custom) { return custom.field; });
            }
            return [];
        };
        AgTableColComponent.prototype.setWidth = function () {
            var _this = this;
            if (this.parent && this.parent.parent.body.itemsContainerEl && this.parent.parent.body.itemsContainerEl.nativeElement) {
                if (!this.widthIsValid()) {
                    var unit = '';
                    if (this.parent.cols.some(function (x, i) { return x.getWidthUnit() !== ''; }))
                        unit = this.parent.cols.find(function (x, i) { return x.getWidthUnit() !== ''; }).getWidthUnit();
                    if (unit === 'px') {
                        var colsWithWidth = this.parent.cols.filter(function (x, i) { return i !== _this.colIndex && x.widthIsValid(); });
                        var widthDiff = colsWithWidth.reduce(function (prev, curr) { return prev + parseFloat(_this.helper.onlyNumbers(curr.width)); }, 0);
                        var containerWidth = this.parent.el.clientWidth;
                        this._width = (containerWidth - widthDiff) / Math.abs(this.parent.cols.length - colsWithWidth.length) + 'px';
                    }
                    else {
                        if (!unit)
                            unit = '%';
                        var colsWithWidth = this.parent.cols.filter(function (x, i) { return i !== _this.colIndex && x.widthIsValid(); });
                        var widthDiff = colsWithWidth.reduce(function (prev, curr) { return prev + parseFloat(_this.helper.onlyNumbers(curr.width)); }, 0);
                        this._width = (100 - widthDiff) / Math.abs(this.parent.cols.length - colsWithWidth.length) + unit;
                    }
                }
                else
                    this._width = this.width;
            }
            else
                this._width = 'auto';
            this.setCellsWidth();
        };
        AgTableColComponent.prototype.setCellsWidth = function () {
            var _this = this;
            if (this.parent && this.parent.parent.body && this.parent.parent.body.rows.length) {
                this.parent.parent.body.rows.forEach(function (row) {
                    var cell = row.cells.find(function (cell) { return cell.cellIndex === _this.colIndex; });
                    if (cell)
                        cell.setWidth();
                });
            }
        };
        AgTableColComponent.ctorParameters = function () { return [
            { type: Helper },
            { type: AgTableLangService },
            { type: forms.FormBuilder },
            { type: core.ElementRef }
        ]; };
        __decorate([
            core.HostBinding('class.ag-table-col')
        ], AgTableColComponent.prototype, "_class", void 0);
        __decorate([
            core.Input()
        ], AgTableColComponent.prototype, "width", void 0);
        __decorate([
            core.Input('custom-filter')
        ], AgTableColComponent.prototype, "customFilter", void 0);
        __decorate([
            core.Input()
        ], AgTableColComponent.prototype, "filter", void 0);
        __decorate([
            core.Input()
        ], AgTableColComponent.prototype, "field", void 0);
        __decorate([
            core.Input()
        ], AgTableColComponent.prototype, "mode", void 0);
        __decorate([
            core.Input()
        ], AgTableColComponent.prototype, "placeholder", void 0);
        __decorate([
            core.Input('date-format')
        ], AgTableColComponent.prototype, "dateFormat", void 0);
        __decorate([
            core.Input('option-all-label')
        ], AgTableColComponent.prototype, "optionAllLabel", void 0);
        __decorate([
            core.Input()
        ], AgTableColComponent.prototype, "options", void 0);
        __decorate([
            core.Input('no-sort')
        ], AgTableColComponent.prototype, "noSort", void 0);
        __decorate([
            core.Input('no-truncate')
        ], AgTableColComponent.prototype, "noTruncate", void 0);
        __decorate([
            core.Input('sort')
        ], AgTableColComponent.prototype, "sort", void 0);
        __decorate([
            core.Input('disable-filter')
        ], AgTableColComponent.prototype, "disableFilter", void 0);
        __decorate([
            core.Input('filter-value')
        ], AgTableColComponent.prototype, "filterValue", void 0);
        AgTableColComponent = __decorate([
            core.Component({
                selector: 'ag-table-col',
                template: "<span *ngIf=\"!noSort\" class=\"ag-table-col-sort\" (click)=\"toggleSort()\" [ngClass]=\"{ 'sort-none': !isSorting, 'sort-asc': isSorting && isSortAsc, 'sort-desc': isSorting && !isSortAsc }\"></span>\n\n<div class=\"w-auto\" [ngClass]=\"{ 'text-truncate': !noTruncate && !customFilter }\">\n    <ng-content></ng-content>\n</div>\n\n<div *ngIf=\"canFiltering && parent?.filterCtrls\">\n    <ag-table-filter *ngFor=\"let field of fields\"\n        [frmControl]=\"parent?.filterCtrls[field]\"\n        [type]=\"filter\"\n        [placeholder]=\"placeholder\"\n        [dateFormat]=\"dateFormat\"\n        [optionAllLabel]=\"optionAllLabel\"\n        [options]=\"options\"\n        (onChange)=\"onFiltering()\" \n        (onRender)=\"onFilterRender()\"> \n    </ag-table-filter>\n</div>"
            })
        ], AgTableColComponent);
        return AgTableColComponent;
    }());

    var AgTableHeaderComponent = /** @class */ (function () {
        function AgTableHeaderComponent(elRef, helper, fb) {
            this.elRef = elRef;
            this.helper = helper;
            this.fb = fb;
            this.class = true;
            this.dictionary = TRANSLATION$1;
            this.colSorting = null;
            this.frmFilter = this.fb.group({ none: [null] });
        }
        Object.defineProperty(AgTableHeaderComponent.prototype, "cols", {
            get: function () { return this.queryCols ? this.queryCols.toArray() : []; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AgTableHeaderComponent.prototype, "height", {
            get: function () { return (this.el) ? this.el.children[0].clientHeight + "px" : '0px'; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AgTableHeaderComponent.prototype, "visible", {
            get: function () { return (this.elRef && this.el) ? this.el.style.visibility !== 'hidden' : false; },
            set: function (value) {
                if ((this.elRef && this.el))
                    this.el.style.visibility = (value ? '' : 'hidden');
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AgTableHeaderComponent.prototype, "filterCtrls", {
            get: function () { return (this.frmFilter && this.frmFilter.controls) ? this.frmFilter.controls : null; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AgTableHeaderComponent.prototype, "el", {
            get: function () { return (this.elRef && this.elRef.nativeElement) ? this.elRef.nativeElement : null; },
            enumerable: true,
            configurable: true
        });
        AgTableHeaderComponent.prototype.ngOnInit = function () {
        };
        AgTableHeaderComponent.prototype.ngAfterViewInit = function () {
        };
        AgTableHeaderComponent.prototype.makeForm = function () {
            var objControls = {};
            this.cols.forEach(function (col) {
                if (col.canFilter) {
                    if (col.field) {
                        objControls[col.field] = col.makeFormControl();
                        if (col.disableFilter) {
                            objControls[col.field].disable();
                        }
                    }
                    else {
                        col.customFilter.forEach(function (custom) {
                            objControls[custom.field] = col.makeFormControl(custom.value ? custom.value : null);
                            if (col.disableFilter) {
                                objControls[col.field].disable();
                            }
                        });
                    }
                }
            });
            if (Object.keys(objControls).length === 0)
                objControls['none'] = this.fb.control(null);
            this.frmFilter = this.fb.group(objControls);
            if (this.parent && this.parent.loading)
                this.frmFilter.disable();
        };
        AgTableHeaderComponent.prototype.enableForm = function () {
            var _this = this;
            this.cols.forEach(function (col) {
                if (col.canFilter) {
                    if (col.field)
                        _this.checkFilterStatus(col.field, col);
                    else if (col.customFilter)
                        col.customFilter.forEach(function (custom) {
                            _this.checkFilterStatus(custom.field, col);
                        });
                }
            });
        };
        AgTableHeaderComponent.prototype.checkFilterStatus = function (field, col) {
            var control = this.filterCtrls[field];
            if (control) {
                if (col.disableFilter)
                    control.disable();
                else
                    control.enable();
            }
        };
        AgTableHeaderComponent.prototype.checkDefaultValue = function (field, value, col) {
            var control = this.filterCtrls[field];
            if (control && value)
                control.setValue(col.filterValue);
        };
        AgTableHeaderComponent.prototype.onRender = function (parent) {
            this.parent = parent;
            this.configureChildrens();
            this.queryCols.changes.subscribe(this.configureChildrens.bind(this));
            this.onBodyWidthChange(this.parent.lastBodyWidth);
        };
        AgTableHeaderComponent.prototype.configureChildrens = function () {
            var _this = this;
            this.makeForm();
            this.cols.forEach(function (col, index) {
                col.onRender(_this, index);
                if (col.field)
                    _this.checkDefaultValue(col.field, col.filterValue, col);
                else if (col.customFilter)
                    col.customFilter.forEach(function (custom) {
                        _this.checkDefaultValue(custom.field, custom.value, col);
                    });
            });
            if (this.colSorting) {
                if (this.parent.initialized)
                    this.parent.onSortChange();
            }
            else if (this.cols.some(function (x) { return x.sort === 'asc' || x.sort === 'desc'; })) {
                var colSort = this.cols.find(function (x) { return x.sort === 'asc' || x.sort === 'desc'; });
                this.colSorting = {
                    col: colSort,
                    asc: colSort.sort === 'asc'
                };
                colSort.sort = null;
                if (this.parent.initialized)
                    this.parent.onSortChange();
            }
            if (this.parent)
                this.parent.definePaddingTop();
        };
        AgTableHeaderComponent.prototype.getColByField = function (field) {
            return this.cols.find(function (col) {
                if (col.field)
                    return col.field === field;
                else if (col.customFilter)
                    return col.customFilter.some(function (x) { return x.field === field; });
                return false;
            });
        };
        AgTableHeaderComponent.prototype.getColFilterModeByField = function (field) {
            var col = this.getColByField(field);
            if (col) {
                if (col.field)
                    return col.mode;
                else if (col.customFilter) {
                    var customFilter = col.customFilter.find(function (x) { return x.field === field; });
                    if (customFilter)
                        return customFilter.mode;
                }
            }
            return exports.AgTableFilterMode.CONTAINS;
        };
        AgTableHeaderComponent.prototype.getFormDataModel = function () {
            var formValue = this.frmFilter.value;
            var dataModel = {};
            for (var field in formValue) {
                var value = formValue[field];
                if (!util.isNullOrUndefined(value) && value !== '')
                    dataModel[field] = value;
            }
            return dataModel;
        };
        AgTableHeaderComponent.prototype.onBodyWidthChange = function (currentWidth) {
            if (currentWidth && this.el) {
                var currentWidthNumber = this.helper.onlyNumberAndToFloat(currentWidth);
                var minWidthIsDefined = !!(this.parent && this.parent.minWidth);
                var headerWidth = this.el.clientWidth;
                if (minWidthIsDefined) {
                    this.el.style.width = currentWidth;
                    headerWidth = this.parent.el.clientWidth;
                }
                else
                    this.el.style.width = '';
                if (this.cols.length > 0) {
                    this.cols.forEach(function (col) { return col.setWidth(); });
                    var lastCol = this.cols[this.cols.length - 1];
                    if (headerWidth > currentWidthNumber) {
                        this.el.style.paddingRight = minWidthIsDefined ? '' : ((headerWidth - currentWidthNumber) + 'px');
                        lastCol.el.style.paddingRight = '0px';
                    }
                    else {
                        this.el.style.paddingRight = '';
                        lastCol.el.style.paddingRight = '';
                    }
                }
            }
        };
        AgTableHeaderComponent.prototype.ngOnDestroy = function () {
        };
        AgTableHeaderComponent.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: Helper },
            { type: forms.FormBuilder }
        ]; };
        __decorate([
            core.HostBinding('class.ag-table-header')
        ], AgTableHeaderComponent.prototype, "class", void 0);
        __decorate([
            core.ContentChildren(AgTableColComponent)
        ], AgTableHeaderComponent.prototype, "queryCols", void 0);
        AgTableHeaderComponent = __decorate([
            core.Component({
                selector: 'ag-table-header',
                template: "<form [formGroup]=\"frmFilter\">\n    <ng-content></ng-content>\n</form>"
            })
        ], AgTableHeaderComponent);
        return AgTableHeaderComponent;
    }());

    var TRANSLATION$3 = {
        EMPTY: {
            ptBR: 'Você não tem dados para serem exibidos.',
            enUS: 'You do not have data to display.'
        }
    };

    var TRANSLATION$4 = {};

    var TRANSLATION$5 = {};

    var AgTableCellComponent = /** @class */ (function () {
        function AgTableCellComponent(elRef, helper, detectorRef) {
            this.elRef = elRef;
            this.helper = helper;
            this.detectorRef = detectorRef;
            this.class = true;
            this.noTruncate = false;
            this.cellIndex = null;
            this.destroyed = false;
            this.dictionary = TRANSLATION$5;
            this.truncate = !this.noTruncate;
        }
        Object.defineProperty(AgTableCellComponent.prototype, "truncate", {
            get: function () { return this.el.classList.contains('text-truncate'); },
            set: function (value) {
                if (this.el) {
                    if (value)
                        this.el.classList.add('text-truncate');
                    else
                        this.el.classList.remove('text-truncate');
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AgTableCellComponent.prototype, "col", {
            get: function () {
                if (!util.isNullOrUndefined(this.cellIndex) &&
                    this.parent &&
                    this.parent.parent &&
                    this.parent.parent.parent &&
                    this.parent.parent.parent.header &&
                    this.parent.parent.parent.header.cols) {
                    if (this.cellIndex < this.parent.parent.parent.header.cols.length)
                        return this.parent.parent.parent.header.cols[this.cellIndex];
                    else {
                        console.error('There are more cells than columns. Please fix this.');
                        return null;
                    }
                }
                return null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AgTableCellComponent.prototype, "el", {
            get: function () { return (this.elRef && this.elRef.nativeElement) ? this.elRef.nativeElement : null; },
            enumerable: true,
            configurable: true
        });
        AgTableCellComponent.prototype.ngOnInit = function () {
        };
        AgTableCellComponent.prototype.ngOnChanges = function (changes) {
            if (changes) {
                if ('noTruncate' in changes) {
                    this.noTruncate = (typeof this.noTruncate === 'string' && (this.noTruncate === '' || this.noTruncate === 'true')) ? true : this.noTruncate;
                    this.truncate = !this.noTruncate && (!this.parent || !this.parent.noTruncate);
                }
            }
        };
        AgTableCellComponent.prototype.onRender = function (parent, index) {
            this.cellIndex = index;
            this.parent = parent;
            this.truncate = !this.noTruncate && (!this.parent || !this.parent.noTruncate);
            this.setWidth();
        };
        AgTableCellComponent.prototype.setWidth = function () {
            if (this.elRef && this.el) {
                var newWidth = this.col ? this.col._width : 'auto';
                var newMaxWidth = newWidth;
                if (newWidth && newWidth.endsWith('%'))
                    newMaxWidth = ((this.helper.onlyNumberAndToFloat(newWidth) * this.parent.parent.el.clientWidth) / 100) + 'px';
                if (newWidth !== this.el.style.width || newMaxWidth !== this.el.style.maxWidth) {
                    this.el.style.width = newWidth;
                    this.el.style.maxWidth = newMaxWidth;
                }
            }
        };
        AgTableCellComponent.prototype.ngOnDestroy = function () {
        };
        AgTableCellComponent.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: Helper },
            { type: core.ChangeDetectorRef }
        ]; };
        __decorate([
            core.HostBinding('class.ag-table-cell')
        ], AgTableCellComponent.prototype, "class", void 0);
        __decorate([
            core.Input('no-truncate')
        ], AgTableCellComponent.prototype, "noTruncate", void 0);
        AgTableCellComponent = __decorate([
            core.Component({
                selector: 'ag-table-cell',
                template: "<ng-content></ng-content>"
            })
        ], AgTableCellComponent);
        return AgTableCellComponent;
    }());

    var AgTableRowComponent = /** @class */ (function () {
        function AgTableRowComponent(elRef, viewContainer) {
            this.elRef = elRef;
            this.viewContainer = viewContainer;
            this.class = true;
            this.noTruncate = false;
            this.dictionary = TRANSLATION$4;
        }
        Object.defineProperty(AgTableRowComponent.prototype, "_height", {
            get: function () { return (this.el) ? this.el.style.minHeight : 'auto'; },
            set: function (value) {
                if (this.el) {
                    this.el.style.minHeight = value;
                    this.el.style.height = value;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AgTableRowComponent.prototype, "cells", {
            get: function () { return this.queryCells ? this.queryCells.toArray() : []; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AgTableRowComponent.prototype, "el", {
            get: function () { return (this.elRef && this.elRef.nativeElement) ? this.elRef.nativeElement : null; },
            enumerable: true,
            configurable: true
        });
        AgTableRowComponent.prototype.ngOnInit = function () {
        };
        AgTableRowComponent.prototype.ngOnChanges = function (changes) {
            var _this = this;
            if (changes) {
                if ('noTruncate' in changes) {
                    this.noTruncate = (typeof this.noTruncate === 'string' && (this.noTruncate === '' || this.noTruncate === 'true')) ? true : this.noTruncate;
                    if (this.cells.length)
                        this.cells.forEach(function (cell) {
                            cell.truncate = !cell.noTruncate && !_this.noTruncate;
                        });
                }
            }
        };
        AgTableRowComponent.prototype.ngAfterViewInit = function () {
        };
        AgTableRowComponent.prototype.onRender = function (parent, virtualIndex) {
            this.parent = parent;
            this.virtualIndex = virtualIndex;
            this.index = this.parent.getRowIndexBasedVirtual(virtualIndex);
            this._height = this.parent.rowHeight;
            this.configureChildrens();
            this.defineClass();
            if (this.subscription)
                this.subscription.unsubscribe();
            this.subscription = this.queryCells.changes.subscribe(this.configureChildrens.bind(this));
        };
        AgTableRowComponent.prototype.configureChildrens = function () {
            var _this = this;
            this.cells.forEach(function (cell, index) {
                cell.onRender(_this, index);
            });
        };
        AgTableRowComponent.prototype.defineClass = function () {
            if (this.index >= 0) {
                var position = this.index + 1;
                var currentClassName = 'ag-table-row-' + ((position % 2) === 0 ? 'even' : 'odd');
                var previousClassName = 'ag-table-row-' + ((position % 2) === 0 ? 'odd' : 'even');
                if (!this.el.classList.contains(currentClassName))
                    this.el.classList.add(currentClassName);
                if (this.el.classList.contains(previousClassName))
                    this.el.classList.remove(previousClassName);
            }
        };
        AgTableRowComponent.prototype.ngOnDestroy = function () {
            if (this.subscription)
                this.subscription.unsubscribe();
        };
        AgTableRowComponent.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: core.ViewContainerRef }
        ]; };
        __decorate([
            core.HostBinding('class.ag-table-row')
        ], AgTableRowComponent.prototype, "class", void 0);
        __decorate([
            core.ContentChildren(AgTableCellComponent)
        ], AgTableRowComponent.prototype, "queryCells", void 0);
        __decorate([
            core.Input('no-truncate')
        ], AgTableRowComponent.prototype, "noTruncate", void 0);
        AgTableRowComponent = __decorate([
            core.Component({
                selector: 'ag-table-row',
                template: "<ng-content></ng-content>"
            })
        ], AgTableRowComponent);
        return AgTableRowComponent;
    }());

    var AgTableVirtualScrollModel = /** @class */ (function () {
        function AgTableVirtualScrollModel(obj) {
            this.currentStartIndex = 0;
            this.currentEndIndex = 0;
            this.totalHeightContent = 0;
            this.paddingScroll = 0;
            this.previousItemsHeight = [];
            if (obj)
                Object.assign(this, obj);
        }
        Object.defineProperty(AgTableVirtualScrollModel.prototype, "currentSrollTop", {
            get: function () { return (this.containerSrollEl && this.containerSrollEl.nativeElement) ? this.containerSrollEl.nativeElement.scrollTop : 0; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AgTableVirtualScrollModel.prototype, "scrollHeight", {
            get: function () { return (this.containerSrollEl && this.containerSrollEl.nativeElement) ? this.containerSrollEl.nativeElement.scrollHeight : 0; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AgTableVirtualScrollModel.prototype, "height", {
            get: function () { return (this.containerSrollEl && this.containerSrollEl.nativeElement) ? this.containerSrollEl.nativeElement.clientHeight : 0; },
            enumerable: true,
            configurable: true
        });
        return AgTableVirtualScrollModel;
    }());

    var AgTableDataRenderEvent = /** @class */ (function () {
        function AgTableDataRenderEvent(obj) {
            this.items = [];
            this.length = 0;
            this.startIndex = 0;
            this.endIndex = 0;
            Object.assign(this, obj);
        }
        return AgTableDataRenderEvent;
    }());

    var AgTableVirtualScrollService = /** @class */ (function () {
        function AgTableVirtualScrollService(helper) {
            this.helper = helper;
        }
        AgTableVirtualScrollService.prototype.defineItens = function (body) {
            var vs = body.virtualScroll;
            var table = body.parent;
            var dimensions = this.defineDimensions(body);
            vs.paddingScroll = dimensions.paddingTop;
            vs.totalHeightContent = dimensions.heightAllItems;
            vs.currentStartIndex = dimensions.itemsThatAreGone;
            vs.currentEndIndex = vs.currentStartIndex + this.howManyCanAppear(body);
            table.items = table.filteredItems.slice(vs.currentStartIndex, vs.currentEndIndex);
            table.onDataRender.emit(new AgTableDataRenderEvent({
                items: table.items,
                length: table.items.length,
                startIndex: vs.currentStartIndex,
                endIndex: vs.currentEndIndex
            }));
            table.isDataEmpty = table.items.length === 0;
        };
        AgTableVirtualScrollService.prototype.onScrollChange = function (body) {
            var vs = body.virtualScroll;
            for (var i = 0; i < body.itemsContainerEl.nativeElement.children.length; i++) {
                var children = body.itemsContainerEl.nativeElement.children[i];
                var realIndex = vs.currentStartIndex + i;
                if (!vs.previousItemsHeight[realIndex])
                    vs.previousItemsHeight[realIndex] = children.getBoundingClientRect().height;
            }
            this.defineItens(body);
        };
        AgTableVirtualScrollService.prototype.reset = function (body) {
            var vs = body.virtualScroll;
            vs.previousItemsHeight = [];
            vs.totalHeightContent = 0;
            vs.paddingScroll = 0;
        };
        AgTableVirtualScrollService.prototype.defineDimensions = function (body) {
            var e_1, _a;
            var vs = body.virtualScroll;
            var rowHeight = parseInt(this.helper.onlyNumbers(body.rowHeight));
            var obj = {
                paddingTop: 0,
                itemsThatAreGone: 0,
                heightAllItems: 0
            };
            obj.heightAllItems = body.parent.filteredItems.reduce(function (prev, curr, i) {
                var height = vs.previousItemsHeight[i];
                return prev + (height ? height : rowHeight);
            }, 0);
            if (vs.currentSrollTop >= rowHeight) {
                var paddingTop = 0;
                var itemsThatAreGone = 0;
                var initialScroll = vs.currentSrollTop;
                try {
                    for (var _b = __values(vs.previousItemsHeight), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var h = _c.value;
                        var height = h ? h : rowHeight;
                        if (initialScroll >= height) {
                            paddingTop += height;
                            initialScroll -= height;
                            itemsThatAreGone++;
                        }
                        else
                            break;
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
                obj.paddingTop = paddingTop;
                obj.itemsThatAreGone = itemsThatAreGone;
            }
            return obj;
        };
        AgTableVirtualScrollService.prototype.preparePreviousItemAfterDataChange = function (body) {
            var table = body.parent;
            var vs = body.virtualScroll;
            if (!table.infinity)
                vs.previousItemsHeight = new Array(table.filteredItems.length).fill(null);
            else {
                var anothers = table.filteredItems.length - vs.previousItemsHeight.length;
                if (anothers > 0)
                    vs.previousItemsHeight = __spread(vs.previousItemsHeight, (new Array(anothers).fill(null)));
            }
        };
        AgTableVirtualScrollService.prototype.canApplyVirtualScroll = function (body) {
            var vs = body.virtualScroll;
            if (body.parent && body.parent._height !== 'auto')
                return true;
            else {
                var rowHeight = parseInt(this.helper.onlyNumbers(body.rowHeight));
                var avaiableScrollHeight = vs.scrollHeight - vs.height;
                if (avaiableScrollHeight > rowHeight)
                    return (avaiableScrollHeight / rowHeight) >= 1.5;
            }
            return false;
        };
        AgTableVirtualScrollService.prototype.howManyCanAppear = function (body) {
            var vs = body.virtualScroll;
            var rowHeight = parseInt(this.helper.onlyNumbers(body.rowHeight));
            var height = vs.height ? vs.height : parseInt(this.helper.onlyNumbers(body.parent._height));
            return Math.floor((isNaN(height) ? 0 : height) / rowHeight) + 1;
        };
        AgTableVirtualScrollService.ctorParameters = function () { return [
            { type: Helper }
        ]; };
        AgTableVirtualScrollService = __decorate([
            core.Injectable()
        ], AgTableVirtualScrollService);
        return AgTableVirtualScrollService;
    }());

    var AgTableBodyComponent = /** @class */ (function () {
        function AgTableBodyComponent(langService, renderer, helper, elRef, dataVirtualScrollService) {
            this.langService = langService;
            this.renderer = renderer;
            this.helper = helper;
            this.elRef = elRef;
            this.dataVirtualScrollService = dataVirtualScrollService;
            this.class = true;
            this.clickable = false;
            this.minHeight = 40;
            this.rowHeight = this.minHeight + 'px';
            this.emptyMsg = '';
            this.dictionary = TRANSLATION$3;
            this.scrollInBottom = false;
            this.scrollEnabled = false;
            this.lastScrollTop = -1;
            this.eventsLineters = [];
        }
        Object.defineProperty(AgTableBodyComponent.prototype, "heightIsAuto", {
            get: function () { return this.parent && this.parent.height === 'auto'; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AgTableBodyComponent.prototype, "rows", {
            get: function () { return this.queryRows ? this.queryRows.toArray() : []; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AgTableBodyComponent.prototype, "el", {
            get: function () { return (this.elRef && this.elRef.nativeElement) ? this.elRef.nativeElement : null; },
            enumerable: true,
            configurable: true
        });
        AgTableBodyComponent.prototype.ngOnInit = function () {
            this.virtualScroll = new AgTableVirtualScrollModel({
                containerSrollEl: this.elRef
            });
        };
        AgTableBodyComponent.prototype.ngAfterViewInit = function () {
            if (!this.emptyMsg)
                this.emptyMsg = this.langService.getText('EMPTY', this.dictionary);
        };
        AgTableBodyComponent.prototype.ngOnChanges = function (changes) {
            if ('rowHeight' in changes) {
                if (this.helper.onlyNumbers(this.rowHeight) === this.rowHeight)
                    this.rowHeight += 'px';
                if (util.isNullOrUndefined(this.rowHeight) || this.rowHeight === '') {
                    this.rowHeight = this.minHeight + 'px';
                    return;
                }
                else {
                    var number_1 = this.helper.onlyNumbers(this.rowHeight);
                    var unit = this.rowHeight.replace(number_1, '');
                    if (unit !== 'px') {
                        this.rowHeight = this.minHeight + 'px';
                        console.warn("The row-height is invalid. The height must be informed in \"px\".");
                        return;
                    }
                }
                var number = parseInt(this.helper.onlyNumbers(this.rowHeight));
                if (number < this.minHeight) {
                    this.rowHeight = this.minHeight + 'px';
                    console.warn("The row-height is invalid because the minimum height should be \"" + this.minHeight + "px\".");
                    return;
                }
            }
        };
        AgTableBodyComponent.prototype.onRender = function (parent) {
            this.parent = parent;
            this.configureChildrens();
            this.applyListeners();
            this.scrollEnabled = this.parent.loading;
            this.parent.checkMinWidthcanApply();
            if (this.dataVirtualScrollService.canApplyVirtualScroll(this))
                this.dataVirtualScrollService.defineItens(this);
            else
                this.parent.items = this.parent.filteredItems;
            if (this.subscription)
                this.subscription.unsubscribe();
            this.subscription = this.queryRows.changes.subscribe(this.configureChildrens.bind(this));
        };
        AgTableBodyComponent.prototype.configureChildrens = function () {
            var _this = this;
            this.clickable = this.parent.clickable;
            this.rows.forEach(function (row, index) {
                row.onRender(_this, index);
            });
        };
        AgTableBodyComponent.prototype.applyListeners = function () {
            if (this.eventsLineters && this.eventsLineters.length) {
                this.eventsLineters.forEach(function (eventListener) { return eventListener && eventListener(); });
                this.eventsLineters = [];
            }
            this.eventsLineters.push(this.renderer.listen(this.elRef.nativeElement, 'scroll', this.onScroll.bind(this)));
            this.eventsLineters.push(this.renderer.listen(this.elRef.nativeElement, 'mousewheel', this.onMouseWheel.bind(this)));
            this.eventsLineters.push(this.renderer.listen(this.elRef.nativeElement, 'DOMMouseScroll', this.onMouseWheel.bind(this)));
        };
        AgTableBodyComponent.prototype.dataTableInBottom = function () {
            var element = this.elRef.nativeElement;
            return element ? ((element.clientHeight + element.scrollTop) >= element.scrollHeight) : false;
        };
        AgTableBodyComponent.prototype.onScrollFinished = function () {
            if (this.parent.infinity && this.parent && !this.parent.dataAreOver) {
                this.parent.currentPage++;
                this.parent.emitGetData();
            }
        };
        AgTableBodyComponent.prototype.onScroll = function (ev, forceChange) {
            if (forceChange === void 0) { forceChange = false; }
            if (!this.parent.loading) {
                if (this.dataTableInBottom()) {
                    if (!this.scrollInBottom) {
                        this.scrollInBottom = true;
                        this.onScrollFinished();
                    }
                }
                else
                    this.scrollInBottom = false;
            }
            if (this.dataVirtualScrollService.canApplyVirtualScroll(this))
                if (forceChange || this.lastScrollTop !== this.virtualScroll.currentSrollTop) {
                    this.lastScrollTop = this.virtualScroll.currentSrollTop;
                    this.dataVirtualScrollService.onScrollChange(this);
                }
        };
        AgTableBodyComponent.prototype.backToTheTop = function () {
            this.el.scrollTop = 0;
        };
        AgTableBodyComponent.prototype.getRowIndexBasedVirtual = function (virtualIndex) {
            return this.virtualScroll.currentStartIndex + virtualIndex;
        };
        AgTableBodyComponent.prototype.onMouseWheel = function () {
            if (!this.dataVirtualScrollService.canApplyVirtualScroll(this))
                this.onScroll();
        };
        AgTableBodyComponent.prototype.onBodyWidthChange = function (currentWidth) {
            if (currentWidth && this.el) {
                if (this.rows.length)
                    this.rows.forEach(function (row) {
                        row.cells.forEach(function (cell) { return cell.setWidth(); });
                    });
            }
        };
        AgTableBodyComponent.prototype.ngOnDestroy = function () {
            if (this.subscription)
                this.subscription.unsubscribe();
            if (this.eventsLineters && this.eventsLineters.length) {
                this.eventsLineters.forEach(function (eventListener) { return eventListener && eventListener(); });
                this.eventsLineters = [];
            }
        };
        AgTableBodyComponent.ctorParameters = function () { return [
            { type: AgTableLangService },
            { type: core.Renderer2 },
            { type: Helper },
            { type: core.ElementRef },
            { type: AgTableVirtualScrollService }
        ]; };
        __decorate([
            core.HostBinding('class.ag-table-body')
        ], AgTableBodyComponent.prototype, "class", void 0);
        __decorate([
            core.HostBinding('class.clickable')
        ], AgTableBodyComponent.prototype, "clickable", void 0);
        __decorate([
            core.HostBinding('class.height-is-auto')
        ], AgTableBodyComponent.prototype, "heightIsAuto", null);
        __decorate([
            core.ViewChild('itemsContainer', { static: true })
        ], AgTableBodyComponent.prototype, "itemsContainerEl", void 0);
        __decorate([
            core.ContentChildren(AgTableRowComponent)
        ], AgTableBodyComponent.prototype, "queryRows", void 0);
        __decorate([
            core.Input('row-height')
        ], AgTableBodyComponent.prototype, "rowHeight", void 0);
        __decorate([
            core.Input('empty-msg')
        ], AgTableBodyComponent.prototype, "emptyMsg", void 0);
        AgTableBodyComponent = __decorate([
            core.Component({
                selector: 'ag-table-body',
                template: "\n<section [style.height]=\"parent?.items.length ? '100%' : 'auto'\">\n    <div class=\"total-padding\" [style.height.px]=\"virtualScroll.totalHeightContent\"></div>\n    <div #itemsContainer class=\"scrollable-content\"\n        [ngClass]=\"{ 'p-relative': parent?.height === 'auto' }\"\n        [style.transform]=\"'translateY(' + virtualScroll.paddingScroll + 'px)'\"\n        [style.top.px]=\"(parent?.infinity && parent?.loading && parent?.currentPage > 1) ? -80 : 0\"\n    >\n        <ng-content></ng-content>\n    </div>\n</section>\n\n<div class=\"ag-table-empty animated fadeIn\" *ngIf=\"(parent && !parent.loading && !parent.noEmptyView) && rows && rows.length <= 0\">\n    <span [innerHTML]=\"emptyMsg\"></span>   \n</div>\n\n<div *ngIf=\"parent?.infinity\" class=\"ag-table-infinity\" [ngClass]=\"{'ag-table-infinity-show': parent?.loading && parent?.currentPage > 1}\" [style.width.px]=\"itemsContainer.clientWidth\">\n    <div>\n        <ag-table-spinner></ag-table-spinner>\n    </div>\n</div>"
            })
        ], AgTableBodyComponent);
        return AgTableBodyComponent;
    }());

    var AgTableChangeAction;
    (function (AgTableChangeAction) {
        AgTableChangeAction["INITIALIZE"] = "initialization";
        AgTableChangeAction["FILTER"] = "filter";
        AgTableChangeAction["ORDER"] = "order";
        AgTableChangeAction["PAGINATE"] = "paginate";
    })(AgTableChangeAction || (AgTableChangeAction = {}));

    var AgTableEvent = /** @class */ (function () {
        function AgTableEvent(obj) {
            this.page = 1;
            this.pageSize = 0;
            this.order = {};
            this.resetData = false;
            Object.assign(this, obj);
        }
        return AgTableEvent;
    }());

    var AgTablePrepareService = /** @class */ (function () {
        function AgTablePrepareService(helper) {
            this.helper = helper;
        }
        AgTablePrepareService.prototype.apply = function (data, AgTable) {
            if (data && util.isArray(data) && data.length) {
                if (!AgTable.serverSide) {
                    var _data = void 0;
                    var length_1 = data.length;
                    var lengthPaginated = data.length;
                    if (AgTable.isFiltering) {
                        _data = this.applyFilter(data, AgTable);
                        length_1 = _data.length;
                    }
                    if (AgTable.isSorting) {
                        _data = this.applySort(_data ? _data : data, AgTable);
                        length_1 = _data.length;
                    }
                    if (AgTable.isPaging) {
                        _data = this.applyPaginate(_data ? _data : data, AgTable);
                        lengthPaginated = _data.length;
                    }
                    AgTable.setDataLength(length_1, lengthPaginated);
                    return _data ? _data : data;
                }
                return data;
            }
            else {
                if (!AgTable.serverSide)
                    AgTable.setDataLength(0, 0);
                return [];
            }
        };
        AgTablePrepareService.prototype.applyFilter = function (data, table) {
            var _this = this;
            var header = table.header;
            var frm = header.frmFilter;
            if (table.actionChange === AgTableChangeAction.FILTER)
                table.setCurrentPage(1);
            var _data = data.filter(function (item) {
                var ok = true;
                var _loop_1 = function (field) {
                    var value;
                    if (field.includes('.')) {
                        var fields = field.split('.');
                        value = item[fields[0]];
                        fields.slice(1).forEach(function (field) {
                            if (util.isObject(value))
                                value = (field in value) ? value[field] : null;
                        });
                    }
                    else
                        value = item[field];
                    var filterCol = header.getColByField(field);
                    var filterMode = header.getColFilterModeByField(field);
                    var filterValue = frm.controls[field].value;
                    if (filterCol && filterCol.filter === exports.AgTableFilterType.DATE) {
                        value = _this.helper.dateFormat(value, filterCol.dateFormat);
                        filterValue = filterValue;
                    }
                    else {
                        if (filterValue || (typeof filterValue === 'number') || (typeof filterValue === 'boolean'))
                            filterValue = _this.helper.removeAccents(filterValue.toString()).toUpperCase();
                        else
                            filterValue = '';
                        if (value || (typeof value === 'number') || (typeof value === 'boolean'))
                            value = _this.helper.removeAccents(value.toString()).toUpperCase();
                        else
                            value = '';
                    }
                    if (filterCol && !util.isNullOrUndefined(filterValue) && filterValue !== '') {
                        filterValue = _this.helper.removeAccents(filterValue.toString()).toUpperCase();
                        switch (filterMode) {
                            case exports.AgTableFilterMode.CONTAINS:
                                ok = value.includes(filterValue);
                                break;
                            case exports.AgTableFilterMode.EQUALS:
                                ok = value === filterValue;
                                break;
                            case exports.AgTableFilterMode.STARTS_WITH:
                                ok = value.startsWith(filterValue);
                                break;
                            case exports.AgTableFilterMode.ENDS_WITH:
                                ok = value.endsWith(filterValue);
                                break;
                        }
                    }
                    if (!ok)
                        return "break";
                };
                for (var field in frm.controls) {
                    var state_1 = _loop_1(field);
                    if (state_1 === "break")
                        break;
                }
                return ok;
            });
            return _data;
        };
        AgTablePrepareService.prototype.applySort = function (data, table) {
            if (table.actionChange === AgTableChangeAction.ORDER)
                table.setCurrentPage(1);
            if (table.header.colSorting) {
                var col = table.header.colSorting.col;
                var asc_1 = table.header.colSorting.asc;
                var field_1 = '';
                if (!col.field && col.customFilter && col.customFilter.length)
                    field_1 = col.customFilter[0].field;
                else
                    field_1 = col.field;
                var dateRegex_1 = new RegExp('^(-?(?:[1-9][0-9]*)?[0-9]{4})-(1[0-2]|0[1-9])-(3[01]|0[1-9]|[12][0-9])T(2[0-3]|[01][0-9]):([0-5][0-9]):([0-5][0-9])(.[0-9]+)?(Z)?$');
                var _data = data.sort(function (a, b) {
                    var valueA = a[field_1];
                    var valueB = b[field_1];
                    if (typeof valueA === 'string' && dateRegex_1.test(valueA))
                        valueA = new Date(valueA);
                    if (typeof valueB === 'string' && dateRegex_1.test(valueB))
                        valueB = new Date(valueB);
                    if (typeof valueA === 'string' && !isNaN(parseFloat(valueA)))
                        valueA = parseFloat(valueA);
                    if (typeof valueB === 'string' && !isNaN(parseFloat(valueB)))
                        valueB = parseFloat(valueB);
                    if (valueA < valueB)
                        return asc_1 ? -1 : 1;
                    if (valueA > valueB)
                        return asc_1 ? 1 : -1;
                    return 0;
                });
                return _data;
            }
            return data;
        };
        AgTablePrepareService.prototype.applyPaginate = function (data, table) {
            var currentPage = table.currentPage;
            var size = table.paginate;
            var begin = (currentPage - 1) * size;
            var end = begin + size;
            var _data = data.slice(begin, end);
            return _data;
        };
        AgTablePrepareService.ctorParameters = function () { return [
            { type: Helper }
        ]; };
        AgTablePrepareService = __decorate([
            core.Injectable()
        ], AgTablePrepareService);
        return AgTablePrepareService;
    }());

    var TRANSLATION$6 = {
        TOTAL_CAPTION: {
            ptBR: 'Exibindo de {{start}} até {{end}} de {{total}} .',
            enUS: 'Displaying from {{start}} to {{end}} of {{total}} .'
        },
        WITHOUT_TOTAL_CAPTION: {
            ptBR: 'Exibindo de {{start}} até {{end}} registros.',
            enUS: 'Displaying from {{start}} to {{end}} records.'
        }
    };

    var AgTablePaginateComponent = /** @class */ (function () {
        function AgTablePaginateComponent(elRef) {
            this.elRef = elRef;
            this.class = true;
            this.length = 0;
            this.current = 1;
            this.disabled = false;
            this.loading = false;
            this.change = new core.EventEmitter();
            this.dictionary = TRANSLATION$6;
            this.pages = [];
        }
        Object.defineProperty(AgTablePaginateComponent.prototype, "el", {
            get: function () { return (this.elRef && this.elRef.nativeElement) ? this.elRef.nativeElement : null; },
            enumerable: true,
            configurable: true
        });
        AgTablePaginateComponent.prototype.ngOnInit = function () {
        };
        AgTablePaginateComponent.prototype.onRender = function (parent) {
            this.parent = parent;
            this.parent.checkMinWidthcanApply();
        };
        AgTablePaginateComponent.prototype.ngOnChanges = function (changes) {
            if ('length' in changes || 'current' in changes)
                this.generate();
        };
        AgTablePaginateComponent.prototype.pageClick = function (page) {
            if (!this.disabled && (typeof page) !== 'string' && page >= 1 && page <= this.length && page !== this.current) {
                this.current = page;
                this.change.emit(this.current);
                this.generate();
            }
        };
        AgTablePaginateComponent.prototype.generate = function () {
            var e_1, _a;
            var current = this.current, last = this.length, delta = 2, left = current - delta, right = current + delta + 1, range = [], rangeWithDots = [], l;
            if (this.current > 0 && this.length > 0) {
                for (var i = 1; i <= last; i++) {
                    if (i === 1 || i === last || i >= left && i < right)
                        range.push(i);
                }
                try {
                    for (var range_1 = __values(range), range_1_1 = range_1.next(); !range_1_1.done; range_1_1 = range_1.next()) {
                        var i = range_1_1.value;
                        if (l) {
                            if (i - l === 2)
                                rangeWithDots.push(l + 1);
                            else if (i - l !== 1)
                                rangeWithDots.push('...');
                        }
                        rangeWithDots.push(i);
                        l = i;
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (range_1_1 && !range_1_1.done && (_a = range_1.return)) _a.call(range_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
            }
            this.pages = rangeWithDots;
        };
        AgTablePaginateComponent.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        __decorate([
            core.HostBinding('class.ag-table-paginate')
        ], AgTablePaginateComponent.prototype, "class", void 0);
        __decorate([
            core.Input()
        ], AgTablePaginateComponent.prototype, "length", void 0);
        __decorate([
            core.Input()
        ], AgTablePaginateComponent.prototype, "current", void 0);
        __decorate([
            core.Input()
        ], AgTablePaginateComponent.prototype, "disabled", void 0);
        __decorate([
            core.Input()
        ], AgTablePaginateComponent.prototype, "loading", void 0);
        __decorate([
            core.Input()
        ], AgTablePaginateComponent.prototype, "objCaption", void 0);
        __decorate([
            core.Output()
        ], AgTablePaginateComponent.prototype, "change", void 0);
        AgTablePaginateComponent = __decorate([
            core.Component({
                selector: 'ag-table-paginate',
                template: "<span *ngIf=\"objCaption && !loading\" class=\"caption animated fadeIn\" [ngClass]=\"{ 'p-b-7': (length <= 1 || pages.length === 0) }\">\n\t{{ (objCaption.total ? 'TOTAL_CAPTION' : 'WITHOUT_TOTAL_CAPTION') | translate:dictionary:objCaption }}\n</span>\n\n<ul *ngIf=\"length > 1 && pages.length > 0\">\n\t<li [ngClass]=\"{'disabled': current <= 1}\" class=\"animated fadeIn\">\n\t\t<button (click)=\"pageClick(current - 1)\">\n\t\t\t<i class=\"arrow-prev\"></i>\n\t\t</button>\n\t</li>\n\t<li *ngFor=\"let page of pages\" class=\"animated fadeIn\"\n\t\t[ngClass]=\"{'actived': page === current, 'disabled': disabled, 'interval': page === '...'}\">\n\t\t<button (click)=\"pageClick(page)\">\n\t\t\t<span>{{page}}</span>\n\t\t</button>\n\t</li>\n\t<li [ngClass]=\"{'disabled': current >= length}\" class=\"animated fadeIn\">\n\t\t<button (click)=\"pageClick(current + 1)\">\n\t\t\t<i class=\"arrow-next\"></i>\n\t\t</button>\n\t</li>\n</ul>"
            })
        ], AgTablePaginateComponent);
        return AgTablePaginateComponent;
    }());

    var AgTableComponent = /** @class */ (function () {
        function AgTableComponent(elRef, helper, dataPrepareService, dataVirtualScrollService) {
            this.elRef = elRef;
            this.helper = helper;
            this.dataPrepareService = dataPrepareService;
            this.dataVirtualScrollService = dataVirtualScrollService;
            this.class = true;
            /** THAT WILL DEFINE THE DATA TABLE HEIGHT, AND IT WILL HAS SCROLL BAR IN CASE OF OVERFLOW.*/
            this.height = 'auto';
            /** THIS DEFINE IF WILL GO PAGINATE OR NOT */
            this.paginate = null;
            /** THIS DEFINE IF WILL GO BRING DATA BASED ON SCROLLING WHEN TO ARRIVE ON BOTTOM. (BUT USE THIS ONLY WITH SERVER-SIDE) */
            this.infinity = null;
            /** SHOW LOADING SPINNER ABOVE THE DATA TABLE WHEN LOADING IS TRUE. */
            this.loading = null;
            /** THE TOTAL DATA LENGTH. THIS IS USED FOR MAKE THE PAGINATION. */
            this.dataLength = 0;
            /** DETERMINES WHETHER DATA WILL BE SWALLOWED VIA SERVER-SIDE */
            this.serverSide = false;
            /** CALL REQUEST DATA ON INITIALIZATION DATA TABLE */
            this.getDataOnInit = false;
            /** SET THE CURRENT PAGE WHEN USE PAGINATION */
            this.currentPage = 1;
            /** NOTIFIES THAT THE DATA IS GONE (INFINITE-SCROLL ONLY). */
            this.dataAreOver = false;
            /** SETS WHETHER TO DISPLAY EMPTY-VIEW OR NOT. */
            this.noEmptyView = false;
            /** SETS A MINIMUM HEIGHT IN AG-TABLE. */
            this.minHeight = '';
            /** SETS A MINIMUM WIDTH IN AG-TABLE. WHEN THE MINIMUM WIDTH IS REACHED, THE SIDE TABLE WILL SCROLL HORIZONTALLY. */
            this.minWidth = '';
            this.allItems = [];
            /** CALL/EMIT EVENT TO GET DATA (SERVER-SIDE) */
            this.onGetData = new core.EventEmitter();
            /** EMIT EVENT WICH ITEMS HAVEN BEEN RENDERED */
            this.onDataRender = new core.EventEmitter();
            /** EMIT EVENT WHEN THE ag-table HAS ALL BEEN RENDERED */
            this.onTableRender = new core.EventEmitter();
            this.filterActivated = new core.EventEmitter();
            this.items = [];
            this.filteredItems = [];
            this.dictionary = TRANSLATION;
            this.initialized = false;
            this.isDataEmpty = false;
            this.dataPaginatedLength = 0;
            this.actionChange = AgTableChangeAction.INITIALIZE;
            this.DOMisVisible = false;
            this.DOMcountVisibleChange = 0;
            this.lastBodyWidth = null;
            this.lastBodyHeight = null;
        }
        Object.defineProperty(AgTableComponent.prototype, "showEmptyView", {
            get: function () { return this.isDataEmpty && !this.noEmptyView; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AgTableComponent.prototype, "paddingTop", {
            get: function () { return this.elRef && this.elRef.nativeElement ? this.elRef.nativeElement.style.paddingTop : '0px'; },
            set: function (value) { if (this.elRef && this.elRef.nativeElement)
                this.elRef.nativeElement.style.paddingTop = value; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AgTableComponent.prototype, "_height", {
            get: function () { return (this.el && this.el.style.height) ? this.el.style.height : 'auto'; },
            set: function (value) {
                this.el.style.height = value;
                if (this.header) {
                    if (value === '0' || value === '0px')
                        this.header.visible = false;
                    else
                        this.header.visible = true;
                }
                this.definePaddingTop();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AgTableComponent.prototype, "_minHeight", {
            get: function () { return (this.el && this.el.style.minHeight) ? this.el.style.minHeight : ''; },
            set: function (value) {
                this.el.style.minHeight = value;
                this.definePaddingTop();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AgTableComponent.prototype, "header", {
            get: function () { return this.queryHeader ? this.queryHeader.first : null; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AgTableComponent.prototype, "body", {
            get: function () { return this.queryBody ? this.queryBody.first : null; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AgTableComponent.prototype, "topShadow", {
            get: function () {
                if (this.height !== 'auto') {
                    var body = (this.body) ? this.body.el : null;
                    var header = (this.header) ? this.header.el : null;
                    if (body && header)
                        return body.scrollTop >= (header.clientHeight / 2);
                }
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AgTableComponent.prototype, "bottomShadow", {
            get: function () {
                if (this.height !== 'auto') {
                    var body = (this.body) ? this.body.el : null;
                    var header = (this.header) ? this.header.el : null;
                    if (body && header)
                        return (body.scrollTop + body.clientHeight) < body.scrollHeight;
                }
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AgTableComponent.prototype, "isPaging", {
            get: function () { return this.paginate; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AgTableComponent.prototype, "isSorting", {
            get: function () { return this.header && this.header.colSorting; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AgTableComponent.prototype, "isFiltering", {
            get: function () { return ((this.header && this.header.cols) ? this.header.cols.some(function (x) { return x.canFilter; }) : false); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AgTableComponent.prototype, "numPages", {
            get: function () {
                if (this.dataLength && this.isPaging) {
                    var pages = Math.floor(this.dataLength / this.paginate);
                    return pages + (((this.dataLength / this.paginate) > pages) ? 1 : 0);
                }
                else
                    return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AgTableComponent.prototype, "el", {
            get: function () { return (this.elRef && this.elRef.nativeElement) ? this.elRef.nativeElement : null; },
            enumerable: true,
            configurable: true
        });
        AgTableComponent.prototype.ngOnInit = function () {
        };
        AgTableComponent.prototype.ngAfterViewInit = function () {
            var _this = this;
            setTimeout(function () {
                if (_this.body.el) {
                    _this.lastBodyWidth = _this.body.el.clientWidth + 'px';
                    _this.lastBodyHeight = _this.body.el.clientHeight + 'px';
                }
                _this.body.onRender(_this);
                _this.header.onRender(_this);
                if (_this.paginateComp)
                    _this.paginateComp.onRender(_this);
                _this.queryHeader.changes.subscribe(function () { return _this.definePaddingTop(); });
                _this.definePaddingTop();
                setTimeout(function () { return _this.onTableRender.emit(); });
                if (_this.getDataOnInit)
                    _this.emitGetData();
                if (_this.infinity && !_this.heightIsValid())
                    console.warn("The infinity scroll mode not working, because data table height has not been set.");
                if (!_this.infinity && _this.body)
                    _this.body.backToTheTop();
                _this.filterActivated.emit(false);
                _this.initialized = true;
            });
        };
        AgTableComponent.prototype.ngAfterContentChecked = function () {
            if (this.elRef && this.elRef.nativeElement) {
                var elem = this.elRef.nativeElement;
                var visible = !!(elem.offsetWidth || elem.offsetHeight || elem.getClientRects().length);
                if (visible !== this.DOMisVisible) {
                    this.DOMisVisible = visible;
                    if (this.DOMisVisible && this.DOMcountVisibleChange > 0)
                        this.body.onScroll();
                    this.DOMcountVisibleChange++;
                }
            }
            else
                this.DOMisVisible = false;
            this.onCheckBodyDimensions();
        };
        AgTableComponent.prototype.ngOnChanges = function (changes) {
            var _this = this;
            setTimeout(function () {
                if ('serverSide' in changes)
                    _this.serverSide = (typeof _this.serverSide === 'string' && (_this.serverSide === '' || _this.serverSide === 'true')) ? true : _this.serverSide;
                if ('noEmptyView' in changes)
                    _this.noEmptyView = (typeof _this.noEmptyView === 'string' && (_this.noEmptyView === '' || _this.noEmptyView === 'true')) ? true : _this.noEmptyView;
                if ('clickable' in changes) {
                    _this.clickable = (typeof _this.clickable === 'string' && (_this.clickable === '' || _this.clickable === 'true')) ? true : _this.clickable;
                    if (_this.body)
                        _this.body.clickable = _this.clickable;
                }
                if ('height' in changes) {
                    if (_this.height !== 'auto' && !_this.heightIsValid()) {
                        console.warn("The height of table is invalid.");
                        _this.height = 'auto';
                    }
                    _this._height = _this.height;
                    _this.prepareItemsPagingAndFilter();
                    if (!_this.infinity && _this.body)
                        _this.body.backToTheTop();
                }
                if ('minHeight' in changes) {
                    if (_this.minHeight !== 'auto' && !_this.minHeightIsValid()) {
                        console.warn("The minHeight of table is invalid.");
                        _this.minHeight = '';
                    }
                    _this._minHeight = _this.minHeight;
                    _this.prepareItemsPagingAndFilter();
                    if (!_this.infinity && _this.body)
                        _this.body.backToTheTop();
                }
                if ('minWidth' in changes) {
                    if (!_this.minWidthIsValid()) {
                        console.warn("The min-width of table is invalid.");
                        _this.minWidth = '';
                    }
                    if (!_this.minWidthIsValid())
                        _this.stopListenerWidth();
                    else
                        _this.startListenerWidth();
                }
                if ('currentPage' in changes) {
                    if (typeof _this.currentPage === 'string') {
                        if (!isNaN(parseInt(_this.currentPage)))
                            _this.currentPage = parseInt(_this.currentPage);
                        else {
                            console.warn("The current-page value of table is invalid. The current-page value has been defined as 1.");
                            _this.currentPage = 1;
                        }
                    }
                    if (typeof _this.currentPage !== 'number' || _this.currentPage <= 0) {
                        console.warn("The current-page value of table is invalid. The current-page value has been defined as 1.");
                        _this.currentPage = 1;
                    }
                    if (_this.currentPage > _this.paginate && _this.currentPage < 1)
                        _this.currentPage = 1;
                    _this.onPageChange(_this.currentPage, !_this.serverSide);
                }
                if ('paginate' in changes) {
                    if (typeof _this.paginate === 'string') {
                        if (!isNaN(parseInt(_this.paginate)))
                            _this.paginate = parseInt(_this.paginate);
                        else {
                            console.warn("The [paginate] value of table is invalid. The paginate has not been applied.");
                            _this.paginate = null;
                        }
                    }
                    if (_this.isPaging && _this.infinity) {
                        console.warn("The [paginate] has not been applied because [infinity] already has been defined.");
                        _this.paginate = null;
                    }
                    if (_this.paginate) {
                        if (_this.currentPage > _this.paginate)
                            _this.currentPage = 1;
                        if (_this.serverSide)
                            _this.updatePaginateConfig();
                    }
                    _this.onPageChange(_this.currentPage, !_this.serverSide);
                    _this.definePaddingBottom();
                }
                if ('infinity' in changes) {
                    if (typeof _this.infinity === 'string') {
                        if (!isNaN(parseInt(_this.infinity)))
                            _this.infinity = parseInt(_this.infinity);
                        else {
                            console.warn("The [infinity] value of table is invalid. The infinity scroll has not been applied.");
                            _this.infinity = null;
                        }
                    }
                    if (_this.infinity && _this.paginate) {
                        console.warn("The [infinity] has not been applied because [paginate] already has been defined.");
                        _this.infinity = null;
                    }
                    _this.onPageChange(_this.currentPage, !_this.serverSide);
                    _this.definePaddingBottom();
                }
                if ('dataLength' in changes) {
                    if (util.isNullOrUndefined(_this.dataLength))
                        _this.dataLength = 0;
                    _this.updatePaginateConfig();
                    _this.definePaddingBottom();
                }
                if ('getDataOnInit' in changes)
                    _this.getDataOnInit = (typeof _this.getDataOnInit === 'string' && (_this.getDataOnInit === '' || _this.getDataOnInit === 'true')) ? true : _this.getDataOnInit;
                if ('loading' in changes) {
                    setTimeout(function () {
                        if (_this.body)
                            _this.body.scrollEnabled = _this.loading;
                    });
                    if (_this._height.replace('px', '') === '0' && _this.loading)
                        _this.elRef.nativeElement.style.height = '50px';
                    if (_this.header && _this.header.frmFilter) {
                        if (_this.loading)
                            _this.header.frmFilter.disable();
                        else {
                            _this.header.enableForm();
                            _this.updatePaginateConfig();
                        }
                    }
                }
                if ('allItems' in changes) {
                    if (!_this.infinity && _this.currentPage !== 1) {
                        var maxPages = Math.floor(_this.dataLength / _this.paginate);
                        if ((_this.dataLength % _this.paginate) !== 0)
                            maxPages++;
                        if (_this.currentPage > maxPages || !_this.currentPage) {
                            _this.currentPage = (_this.currentPage > maxPages) ? maxPages : 1;
                            if (_this.serverSide) {
                                _this.onPageChange(_this.currentPage);
                                return;
                            }
                        }
                    }
                    _this.refreshRender();
                }
            }, 100);
        };
        AgTableComponent.prototype.onCheckBodyDimensions = function () {
            this.checkBodyWidthChange();
            this.checkBodyHeightChange();
        };
        AgTableComponent.prototype.checkBodyWidthChange = function () {
            if (this.el) {
                var currentWidth = '100%';
                if (this.body && this.body.itemsContainerEl && this.body.itemsContainerEl.nativeElement)
                    currentWidth = this.body.itemsContainerEl.nativeElement.clientWidth + 'px';
                if (currentWidth !== this.lastBodyWidth) {
                    this.lastBodyWidth = currentWidth;
                    this.header.onBodyWidthChange(currentWidth);
                    this.body.onBodyWidthChange(currentWidth);
                }
            }
        };
        AgTableComponent.prototype.checkBodyHeightChange = function () {
            if (this.el && this._height !== 'auto') {
                var currentHeight = this.el.clientHeight + 'px';
                if (currentHeight !== this.lastBodyHeight) {
                    this.lastBodyHeight = currentHeight;
                    this.refreshRender();
                }
            }
        };
        AgTableComponent.prototype.definePaddingBottom = function () {
            if (this.el) {
                var padding = '0px';
                if (!this.infinity && this.paginate !== null)
                    padding = '46px';
                if (padding !== this.elRef.nativeElement.style.paddingBottom)
                    this.el.style.paddingBottom = padding;
            }
        };
        AgTableComponent.prototype.definePaddingTop = function (forceDefine) {
            if (forceDefine === void 0) { forceDefine = false; }
            if (this.el && this.header) {
                var padding = '0px';
                if (this.header && this.header.el && this.header.visible)
                    padding = this.header.height;
                if (forceDefine || padding !== this.elRef.nativeElement.style.paddingTop) {
                    this.paddingTop = padding;
                    if (this.headerShadowEl && this.headerShadowEl.nativeElement)
                        this.headerShadowEl.nativeElement.style.height = padding !== '0px' ? padding : 'auto';
                }
            }
        };
        AgTableComponent.prototype.heightIsValid = function () {
            return !util.isNullOrUndefined(this.height) && (typeof this.height === 'string') && this.height !== '' && this.height !== 'auto';
        };
        AgTableComponent.prototype.minHeightIsValid = function () {
            return !util.isNullOrUndefined(this.minHeight) && (typeof this.minHeight === 'string') && this.minHeight !== '' && this.minHeight !== 'auto';
        };
        AgTableComponent.prototype.minWidthIsValid = function () {
            return !util.isNullOrUndefined(this.minWidth) && (typeof this.minWidth === 'string') && this.minWidth !== '' && this.minWidth !== 'auto';
        };
        AgTableComponent.prototype.startListenerWidth = function () {
            var _this = this;
            this.stopListenerWidth();
            this.intervalListenerWidth = setInterval(function () {
                if (_this.el && _this.minWidthIsValid()) {
                    var width = _this.el.clientWidth;
                    var minWidth = parseInt(_this.helper.onlyNumbers(_this.minWidth));
                    if (width <= minWidth) {
                        _this.el.style.overflowX = 'auto';
                        _this.el.style.overflowY = 'hidden';
                    }
                    else {
                        _this.el.style.overflowX = '';
                        _this.el.style.overflowY = '';
                    }
                }
            }, 250);
        };
        AgTableComponent.prototype.stopListenerWidth = function () {
            if (this.intervalListenerWidth) {
                clearInterval(this.intervalListenerWidth);
                this.intervalListenerWidth = null;
            }
        };
        AgTableComponent.prototype.checkMinWidthcanApply = function () {
            if (this.minWidthIsValid()) {
                if (this.el)
                    this.body.el.style.minWidth = this.minWidth;
                if (this.paginateComp && this.paginateComp.el)
                    this.paginateComp.el.style.minWidth = this.minWidth;
            }
            else {
                if (this.body && this.body.el)
                    this.body.el.style.minWidth = '';
                if (this.paginateComp && this.paginateComp.el)
                    this.paginateComp.el.style.minWidth = '';
            }
        };
        AgTableComponent.prototype.setDataLength = function (length, paginatedLength) {
            this.dataLength = length;
            this.dataPaginatedLength = paginatedLength;
        };
        AgTableComponent.prototype.onPageChange = function (currentPage, emit) {
            if (emit === void 0) { emit = true; }
            if (this.isPaging) {
                this.notifyChanges(AgTableChangeAction.PAGINATE);
                if (emit && this.serverSide) {
                    this.setCurrentPage(currentPage);
                    this.emitGetData();
                }
                else if (!this.serverSide) {
                    this.setCurrentPage(currentPage, false);
                    this.prepareItemsPagingAndFilter();
                    this.updatePaginateConfig();
                    this.body.backToTheTop();
                }
            }
        };
        AgTableComponent.prototype.onSortChange = function () {
            this.notifyChanges(AgTableChangeAction.ORDER);
            if (this.serverSide) {
                this.setCurrentPage(1);
                this.emitGetData(this.infinity > 0);
            }
            else {
                this.prepareItemsPagingAndFilter();
                this.body.backToTheTop();
            }
        };
        AgTableComponent.prototype.onFilterChange = function () {
            this.notifyChanges(AgTableChangeAction.FILTER);
            if (this.header && this.header.cols) {
                if (this.header.cols.some(function (x) { return x.filterActive; })) {
                    this.filterActivated.emit(true);
                }
                else {
                    this.filterActivated.emit(false);
                }
            }
            if (this.serverSide) {
                this.setCurrentPage(1);
                this.emitGetData(this.infinity > 0);
            }
            else {
                this.prepareItemsPagingAndFilter();
                this.updatePaginateConfig();
                this.body.backToTheTop();
            }
        };
        AgTableComponent.prototype.prepareItemsPagingAndFilter = function () {
            this.filteredItems = this.dataPrepareService.apply(this.allItems, this);
            if (this.body && this.dataVirtualScrollService.canApplyVirtualScroll(this.body))
                this.dataVirtualScrollService.defineItens(this.body);
            else {
                this.items = this.filteredItems;
                this.isDataEmpty = this.items.length === 0;
                this.emitDataRender();
            }
        };
        AgTableComponent.prototype.emitGetData = function (resetData) {
            if (resetData === void 0) { resetData = false; }
            if (resetData) {
                this.currentPage = 1;
                this.dataVirtualScrollService.reset(this.body);
            }
            var colSort = this.header.colSorting;
            this.onGetData.emit(new AgTableEvent({
                page: this.currentPage,
                pageSize: this.paginate ? this.paginate : this.infinity,
                filters: this.header.getFormDataModel(),
                order: colSort ? { field: colSort.col.field, asc: colSort.asc } : null,
                resetData: resetData
            }));
        };
        AgTableComponent.prototype.emitDataRender = function () {
            this.onDataRender.emit(new AgTableDataRenderEvent({
                items: this.items,
                length: this.items.length,
                startIndex: 0,
                endIndex: this.items.length - 1
            }));
        };
        AgTableComponent.prototype.setCurrentPage = function (page, updateConfig) {
            if (updateConfig === void 0) { updateConfig = true; }
            this.currentPage = page;
            if (updateConfig)
                this.updatePaginateConfig();
        };
        AgTableComponent.prototype.updatePaginateConfig = function () {
            var visibleLength = this.dataPaginatedLength;
            if (this.serverSide && this.body)
                visibleLength = this.filteredItems.length;
            var page = this.paginate ? this.paginate : this.infinity;
            this.paginateCaptionConfig = {
                start: (page * (this.currentPage - 1)) + 1,
                end: (page * (this.currentPage - 1)) + visibleLength,
                total: this.dataLength ? this.dataLength : 0
            };
        };
        AgTableComponent.prototype.notifyChanges = function (action) {
            if (action === void 0) { action = AgTableChangeAction.INITIALIZE; }
            this.actionChange = action;
        };
        AgTableComponent.prototype.resetFilters = function (getData) {
            if (getData === void 0) { getData = false; }
            for (var ctrlName in this.header.filterCtrls) {
                this.header.filterCtrls[ctrlName].reset();
            }
            if (getData)
                this.emitGetData(true);
        };
        AgTableComponent.prototype.refreshRender = function () {
            if (this.body) {
                if (!this.body.parent)
                    this.body.parent = this;
                this.dataVirtualScrollService.preparePreviousItemAfterDataChange(this.body);
            }
            this.prepareItemsPagingAndFilter();
            this.updatePaginateConfig();
            this.definePaddingBottom();
            if (!this.infinity && this.body)
                this.body.backToTheTop();
        };
        AgTableComponent.prototype.ngOnDestroy = function () {
            this.stopListenerWidth();
        };
        AgTableComponent.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: Helper },
            { type: AgTablePrepareService },
            { type: AgTableVirtualScrollService }
        ]; };
        __decorate([
            core.HostBinding('class.ag-table')
        ], AgTableComponent.prototype, "class", void 0);
        __decorate([
            core.HostBinding('class.ag-table-empty')
        ], AgTableComponent.prototype, "showEmptyView", null);
        __decorate([
            core.ContentChildren(AgTableHeaderComponent)
        ], AgTableComponent.prototype, "queryHeader", void 0);
        __decorate([
            core.ContentChildren(AgTableBodyComponent)
        ], AgTableComponent.prototype, "queryBody", void 0);
        __decorate([
            core.ViewChild(AgTablePaginateComponent, { static: false })
        ], AgTableComponent.prototype, "paginateComp", void 0);
        __decorate([
            core.ViewChild('headerShadowEl', { static: true })
        ], AgTableComponent.prototype, "headerShadowEl", void 0);
        __decorate([
            core.Input()
        ], AgTableComponent.prototype, "height", void 0);
        __decorate([
            core.Input()
        ], AgTableComponent.prototype, "clickable", void 0);
        __decorate([
            core.Input()
        ], AgTableComponent.prototype, "paginate", void 0);
        __decorate([
            core.Input()
        ], AgTableComponent.prototype, "infinity", void 0);
        __decorate([
            core.Input()
        ], AgTableComponent.prototype, "loading", void 0);
        __decorate([
            core.Input('data-length')
        ], AgTableComponent.prototype, "dataLength", void 0);
        __decorate([
            core.Input('server-side')
        ], AgTableComponent.prototype, "serverSide", void 0);
        __decorate([
            core.Input('get-data-init')
        ], AgTableComponent.prototype, "getDataOnInit", void 0);
        __decorate([
            core.Input('current-page')
        ], AgTableComponent.prototype, "currentPage", void 0);
        __decorate([
            core.Input('data-are-over')
        ], AgTableComponent.prototype, "dataAreOver", void 0);
        __decorate([
            core.Input('no-empty-view')
        ], AgTableComponent.prototype, "noEmptyView", void 0);
        __decorate([
            core.Input('min-height')
        ], AgTableComponent.prototype, "minHeight", void 0);
        __decorate([
            core.Input('min-width')
        ], AgTableComponent.prototype, "minWidth", void 0);
        __decorate([
            core.Input('items')
        ], AgTableComponent.prototype, "allItems", void 0);
        __decorate([
            core.Output()
        ], AgTableComponent.prototype, "onGetData", void 0);
        __decorate([
            core.Output()
        ], AgTableComponent.prototype, "onDataRender", void 0);
        __decorate([
            core.Output()
        ], AgTableComponent.prototype, "onTableRender", void 0);
        __decorate([
            core.Output()
        ], AgTableComponent.prototype, "filterActivated", void 0);
        AgTableComponent = __decorate([
            core.Component({
                selector: 'ag-table',
                template: "<div #headerShadowEl class=\"top-shadow animated fadeIn\" [ngClass]=\"{'to-drop': topShadow}\"></div>\n\n<ng-content></ng-content>\n\n<ag-table-paginate *ngIf=\"!infinity && paginate !== null\"\n    class=\"animated fadeIn\"\n    [ngClass]=\"{ 'to-drop': bottomShadow, 'on-infinity': infinity }\"\n    [length]=\"(isPaging && numPages) ? numPages : 1\"\n    [current]=\"(isPaging && numPages) ? currentPage : 1\"\n    [objCaption]=\"(isPaging && numPages) ? paginateCaptionConfig : { start: 1, end: dataLength, total: 0 }\"\n    [loading]=\"loading\"\n    [disabled]=\"loading\"\n    (change)=\"onPageChange($event)\">\n</ag-table-paginate>\n\n<div *ngIf=\"loading && (!infinity || currentPage === 1)\" class=\"ag-table-loading animated fadeIn\">\n    <ag-table-spinner></ag-table-spinner>\n</div>"
            })
        ], AgTableComponent);
        return AgTableComponent;
    }());

    var FILTER_TYPES = Object.keys(exports.AgTableFilterType).map(function (key) { return exports.AgTableFilterType[key]; });

    var TRANSLATION$7 = {
        CURRENCY_PH: {
            ptBR: 'R$',
            enUS: 'USD'
        },
        DATE_FORMAT: {
            ptBR: 'dd/MM/yyyy',
            enUS: 'yyyy/MM/dd'
        },
        YEAR_INITIAL: {
            ptBR: 'a',
            enUS: 'y',
        }
    };

    var AgTableFilterComponent = /** @class */ (function () {
        function AgTableFilterComponent(helper, langService, settings) {
            this.helper = helper;
            this.langService = langService;
            this.settings = settings;
            this.class = true;
            this.currentFilter = '';
            this.type = '';
            this.placeholder = '';
            this.dateFormat = '';
            this.optionAllLabel = '';
            this.options = [];
            /* DISABLED
            @Input() public readOnly: boolean = false;
            @Input() public minDate: Date;
            @Input() public maxDate: Date;
            @Input() public dateSeparator: string = '/'; */
            this.onChange = new core.EventEmitter();
            this.onRender = new core.EventEmitter();
            this.selectAllOptionValue = null;
            this.dictionary = TRANSLATION$7;
        }
        Object.defineProperty(AgTableFilterComponent.prototype, "debounceTime", {
            get: function () {
                if (this.type === 'date' || this.type === 'select')
                    return 0;
                else
                    return this.settings.filterDebounceTime;
            },
            enumerable: true,
            configurable: true
        });
        AgTableFilterComponent.prototype.ngOnInit = function () {
            var _this = this;
            setTimeout(function () {
                _this.onRender.emit();
            });
        };
        AgTableFilterComponent.prototype.ngOnChanges = function (changes) {
            var _this = this;
            if ('options' in changes) {
                if (!util.isArray(this.options)) {
                    console.warn('The options of a filter of type "select" was set invalid.');
                    this.options = [];
                }
                else if (this.options.length) {
                    if (!util.isObject(this.options[0])) {
                        this.options = this.options.map(function (x) {
                            return {
                                text: x,
                                value: x
                            };
                        });
                    }
                    else {
                        this.options = this.options.map(function (x) {
                            return {
                                text: ('text' in x) ? x.text : x.value,
                                value: ('id' in x) ? x.id : x.value
                            };
                        });
                    }
                }
            }
            if ('type' in changes) {
                if (FILTER_TYPES.every(function (x) { return x !== _this.type; }))
                    this.type = exports.AgTableFilterType.TEXT;
            }
            if ('placeholder' in changes) {
                if (!this.placeholder && this.type === 'date')
                    this.placeholder = this.dateFormat.replace(/y/g, this.langService.getText('YEAR_INITIAL', this.dictionary)).toUpperCase();
            }
            if ('frmControl' in changes) {
                if (this.subscription)
                    this.subscription.unsubscribe();
                if (this.frmControl) {
                    this.currentFilter = this.frmControl.value;
                    this.subscription = this.frmControl.valueChanges.pipe(operators.debounceTime(this.debounceTime), operators.map(this.prepareData.bind(this))).subscribe(function (toFilter) {
                        if (toFilter && _this.frmControl.enable)
                            _this.onChange.emit(_this.currentFilter);
                    });
                }
                else
                    this.currentFilter = null;
            }
        };
        AgTableFilterComponent.prototype.prepareData = function () {
            if (this.frmControl.disabled) {
                this.frmControl.disable();
                return false;
            }
            if (this.type === 'select') {
                if (this.frmControl.value === 'undefined' || this.frmControl.value === 'null') {
                    this.currentFilter = this.selectAllOptionValue;
                    this.frmControl.setValue(this.currentFilter);
                    return true;
                }
            }
            if (this.frmControl.value !== this.currentFilter) {
                if (this.type === 'date') {
                    if (this.frmControl.value && !this.helper.dateIsValid(this.frmControl.value, this.dateFormat)) {
                        this.currentFilter = this.selectAllOptionValue;
                        this.frmControl.setValue(null);
                        return false;
                    }
                }
                this.currentFilter = this.frmControl.value;
                if (typeof this.currentFilter === 'string' && this.currentFilter !== '') {
                    if (this.currentFilter === 'null') {
                        this.currentFilter = null;
                        this.frmControl.setValue(this.currentFilter);
                    }
                    else if (this.currentFilter === 'undefined') {
                        this.currentFilter = undefined;
                        this.frmControl.setValue(this.currentFilter);
                    }
                    else if (this.helper.onlyNumbers(this.currentFilter) === this.currentFilter) {
                        this.currentFilter = parseInt(this.currentFilter);
                        this.frmControl.setValue(this.currentFilter);
                    }
                }
            }
            else
                return false;
            return true;
        };
        AgTableFilterComponent.prototype.isEmptyValue = function (value) {
            return util.isNullOrUndefined(value) || value.toString() === '';
        };
        AgTableFilterComponent.prototype.ngOnDestroy = function () {
            if (this.subscription)
                this.subscription.unsubscribe();
        };
        AgTableFilterComponent.ctorParameters = function () { return [
            { type: Helper },
            { type: AgTableLangService },
            { type: AgTableSettings }
        ]; };
        __decorate([
            core.HostBinding('class.ag-table-filter')
        ], AgTableFilterComponent.prototype, "class", void 0);
        __decorate([
            core.Input()
        ], AgTableFilterComponent.prototype, "type", void 0);
        __decorate([
            core.Input()
        ], AgTableFilterComponent.prototype, "placeholder", void 0);
        __decorate([
            core.Input()
        ], AgTableFilterComponent.prototype, "dateFormat", void 0);
        __decorate([
            core.Input()
        ], AgTableFilterComponent.prototype, "optionAllLabel", void 0);
        __decorate([
            core.Input()
        ], AgTableFilterComponent.prototype, "options", void 0);
        __decorate([
            core.Input()
        ], AgTableFilterComponent.prototype, "frmControl", void 0);
        __decorate([
            core.Output()
        ], AgTableFilterComponent.prototype, "onChange", void 0);
        __decorate([
            core.Output()
        ], AgTableFilterComponent.prototype, "onRender", void 0);
        AgTableFilterComponent = __decorate([
            core.Component({
                selector: 'ag-table-filter',
                template: "<input *ngIf=\"type === 'currency'\"\n    class=\"ag-table-filter-input\"\n    type=\"text\"\n    autocomplete=\"off\"\n    [formControl]=\"frmControl\"\n    [placeholder]=\"placeholder ? placeholder : (('CURRENCY_PH' | translate:dictionary) + ' 0,00')\"\n/>\n\n<select *ngIf=\"type === 'select'\" \n    class=\"ag-table-filter-select\"\n    [formControl]=\"frmControl\">\n    <option [value]=\"selectAllOptionValue\">{{optionAllLabel}}</option>\n    <option *ngFor=\"let option of options\" [value]=\"option.value\">{{option.text}}</option>\n</select>\n\n<input *ngIf=\"type === 'text'\"\n    class=\"ag-table-filter-input\"\n    [formControl]=\"frmControl\"\n    type=\"text\"\n    [placeholder]=\"placeholder ? placeholder : ''\"\n/>\n\n<input *ngIf=\"type === 'date'\"\n    class=\"ag-table-filter-input\"\n    [control]=\"frmControl\"\n    [date-format]=\"dateFormat\"\n    type=\"text\"\n    [placeholder]=\"placeholder ? placeholder : dateFormat.toUpperCase()\"\n/>\n\n<input *ngIf=\"type === 'number'\"\n    class=\"ag-table-filter-input\"\n    [formControl]=\"frmControl\"\n    type=\"text\"\n    OnlyNumber\n    [placeholder]=\"placeholder ? placeholder : ''\"\n/>\n"
            })
        ], AgTableFilterComponent);
        return AgTableFilterComponent;
    }());

    var TRANSLATION$8 = {};

    var AgTableSpinnerComponent = /** @class */ (function () {
        function AgTableSpinnerComponent() {
            this.class = true;
            this.dictionary = TRANSLATION$8;
        }
        AgTableSpinnerComponent.prototype.ngOnInit = function () {
        };
        __decorate([
            core.HostBinding('class.ag-table-spinner')
        ], AgTableSpinnerComponent.prototype, "class", void 0);
        AgTableSpinnerComponent = __decorate([
            core.Component({
                selector: 'ag-table-spinner',
                template: "<svg width=\"100\" height=\"100\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\">\n\t<circle cx=\"50\" cy=\"50\" r=\"25\" stroke-linecap=\"round\"/>\n</svg>"
            })
        ], AgTableSpinnerComponent);
        return AgTableSpinnerComponent;
    }());

    var TranslatePipe = /** @class */ (function () {
        function TranslatePipe(langService) {
            this.langService = langService;
        }
        TranslatePipe.prototype.transform = function (prop, dict, replaceObj) {
            if (dict === void 0) { dict = null; }
            var text = '';
            this.langService.getText(prop, dict, false).subscribe(function (result) {
                if (result !== undefined && typeof (result) === 'string') {
                    if (replaceObj && (typeof replaceObj).includes('object')) {
                        for (var property in replaceObj)
                            result = result.replace("{{" + property + "}}", replaceObj[property]);
                    }
                    text = result;
                }
            });
            return text;
        };
        TranslatePipe.ctorParameters = function () { return [
            { type: AgTableLangService }
        ]; };
        TranslatePipe.ɵprov = core.ɵɵdefineInjectable({ factory: function TranslatePipe_Factory() { return new TranslatePipe(core.ɵɵinject(AgTableLangService)); }, token: TranslatePipe, providedIn: "root" });
        TranslatePipe = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            core.Pipe({
                name: 'translate',
                pure: false
            })
        ], TranslatePipe);
        return TranslatePipe;
    }());

    var DateFormatDirective = /** @class */ (function () {
        function DateFormatDirective(helper, settings) {
            this.helper = helper;
            this.settings = settings;
            this.keyCodesAccepts = [8, 9, 37, 38, 39, 40];
            this.ctrlDown = false;
            this.pasting = false;
            this.datePipe = new common.DatePipe(settings.lang);
        }
        DateFormatDirective.prototype.ngOnChanges = function (changes) {
            var _this = this;
            if ('dateFormat' in changes) {
                var regexStr_1 = '';
                if (this.dateFormat) {
                    if (!this.dateFormat.includes('-') && !this.dateFormat.includes('/')) {
                        if (this.dateFormat.toLowerCase() === 'dd')
                            regexStr_1 += '([0-2]\\d{1}|3[0-1])';
                        else if (this.dateFormat.toLowerCase() === 'mm')
                            regexStr_1 += '(0\\d{1}|1[0-2])';
                        else if (this.dateFormat.toLowerCase() === 'yyyy')
                            regexStr_1 += '\\d{4}';
                    }
                    else if (this.dateFormat.includes('-') || this.dateFormat.includes('/')) {
                        this.dateSeparator = this.dateFormat.includes('-') ? '-' : '/';
                        var splitted = this.dateFormat.split(this.dateSeparator);
                        splitted.forEach(function (division) {
                            var divisionRegex = '';
                            if (division.toLowerCase() === 'dd')
                                divisionRegex = '([0-2]\\d{1}|3[0-1])';
                            else if (division.toLowerCase() === 'mm')
                                divisionRegex = '(0\\d{1}|1[0-2])';
                            else if (division.toLowerCase() === 'yyyy')
                                divisionRegex = '\\d{4}';
                            if (divisionRegex)
                                regexStr_1 += (regexStr_1 !== '' ? _this.dateSeparator : '') + divisionRegex;
                        });
                    }
                }
                if (regexStr_1 === '') {
                    this.dateSeparator = '/';
                    this.dateFormat = 'dd/MM/yyyy';
                    regexStr_1 = '([0-2]\\d{1}|3[0-1])/(0\d{1}|1[0-2])/\\d{4}';
                }
                this.regex = new RegExp(regexStr_1, 'g');
            }
        };
        DateFormatDirective.prototype.onKeydown = function (e) {
            var _this = this;
            var input = e.target;
            var code = e.keyCode;
            var key = e.key.toLowerCase();
            if (code == 17 || code == 91)
                this.ctrlDown = true;
            if (this.keyCodesAccepts.some(function (x) { return x === code; }) || (this.ctrlDown && (code == 86 || code == 67 || key === 'a' || key === 'x'))) {
                if ((this.ctrlDown && key === 'x') || code === 8) {
                    if ((input.selectionStart === 0 && input.selectionEnd === input.value.length) || input.value.length === 1)
                        setTimeout(function () { return _this.onBlur(e); });
                }
            }
            else {
                var object = this.generateValue(input.value, e.key);
                if (!util.isNullOrUndefined(object.validValue.match(this.regex))) {
                    input.value = object.formatedValue;
                    if (input.value.length === this.dateFormat.length)
                        this.onBlur(e);
                }
                event.preventDefault();
                return false;
            }
        };
        DateFormatDirective.prototype.onKeyup = function (e) {
            if (e.keyCode == 17 || e.keyCode == 91)
                this.ctrlDown = false;
        };
        DateFormatDirective.prototype.onPaste = function (e) {
            var _this = this;
            if (!this.pasting) {
                var input_1 = e.target;
                var prevValue_1 = input_1.value;
                this.pasting = true;
                setTimeout(function () {
                    _this.pasting = false;
                    var value = _this.helper.onlyNumbers(input_1.value, [_this.dateFormat]);
                    var object = _this.generateValue(value);
                    if (!util.isNullOrUndefined(object.validValue.match(_this.regex))) {
                        input_1.value = object.formatedValue;
                        if (input_1.value.length === _this.dateFormat.length)
                            _this.onBlur(e);
                    }
                    else
                        input_1.value = prevValue_1;
                });
            }
        };
        DateFormatDirective.prototype.onCut = function (e) {
            var _this = this;
            if (!this.pasting) {
                var input_2 = e.target;
                this.pasting = true;
                setTimeout(function () {
                    _this.pasting = false;
                    var value = _this.helper.onlyNumbers(input_2.value, [_this.dateFormat]);
                    var object = _this.generateValue(value);
                    if (!util.isNullOrUndefined(object.validValue.match(_this.regex))) {
                        input_2.value = object.formatedValue;
                    }
                    else
                        input_2.value = '';
                    _this.onBlur(e);
                });
            }
        };
        DateFormatDirective.prototype.onBlur = function (e) {
            if (this.formControl) {
                var input = e.target;
                this.formControl.setValue(input.value);
            }
        };
        DateFormatDirective.prototype.generateValue = function (currentValue, nextChar) {
            if (nextChar === void 0) { nextChar = null; }
            var object = {
                validValue: currentValue,
                formatedValue: '',
            };
            if (currentValue.length !== this.dateFormat.length) {
                var newValue = '';
                if (this.dateSeparator) {
                    for (var i = 0; i < this.dateFormat.length; i++) {
                        var format = this.dateFormat[i];
                        var length_1 = i + 1;
                        if (length_1 <= currentValue.length)
                            newValue += currentValue[i];
                        else if ((length_1 - 1) === currentValue.length) {
                            if (format === this.dateSeparator) {
                                newValue += format;
                                if (nextChar)
                                    i++;
                            }
                            newValue += nextChar ? nextChar : '1';
                            object.formatedValue = newValue;
                        }
                        else
                            newValue += (format !== this.dateSeparator) ? '1' : format;
                    }
                }
                else {
                }
                object.validValue = newValue;
            }
            if (!object.formatedValue)
                object.formatedValue = object.validValue;
            return object;
        };
        DateFormatDirective.prototype.maskDate = function (value) {
        };
        DateFormatDirective.ctorParameters = function () { return [
            { type: Helper },
            { type: AgTableSettings }
        ]; };
        __decorate([
            core.Input('date-format')
        ], DateFormatDirective.prototype, "dateFormat", void 0);
        __decorate([
            core.Input('control')
        ], DateFormatDirective.prototype, "formControl", void 0);
        __decorate([
            core.HostListener('keydown', ['$event'])
        ], DateFormatDirective.prototype, "onKeydown", null);
        __decorate([
            core.HostListener('keyup', ['$event'])
        ], DateFormatDirective.prototype, "onKeyup", null);
        __decorate([
            core.HostListener('paste', ['$event'])
        ], DateFormatDirective.prototype, "onPaste", null);
        __decorate([
            core.HostListener('cut', ['$event'])
        ], DateFormatDirective.prototype, "onCut", null);
        __decorate([
            core.HostListener('blur', ['$event'])
        ], DateFormatDirective.prototype, "onBlur", null);
        DateFormatDirective = __decorate([
            core.Directive({
                selector: '[date-format]'
            })
        ], DateFormatDirective);
        return DateFormatDirective;
    }());

    var AgTableModule = /** @class */ (function () {
        function AgTableModule() {
        }
        AgTableModule = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    router.RouterModule,
                    forms.FormsModule,
                    forms.ReactiveFormsModule,
                ],
                declarations: [
                    AgTableComponent,
                    AgTableHeaderComponent,
                    AgTableBodyComponent,
                    AgTableRowComponent,
                    AgTableCellComponent,
                    AgTableColComponent,
                    AgTableFilterComponent,
                    AgTablePaginateComponent,
                    AgTableSpinnerComponent,
                    // Pipes
                    TranslatePipe,
                    // Directives
                    DateFormatDirective
                ],
                exports: [
                    AgTableComponent,
                    AgTableHeaderComponent,
                    AgTableBodyComponent,
                    AgTableRowComponent,
                    AgTableCellComponent,
                    AgTableColComponent
                ],
                bootstrap: [],
                providers: [
                    AgTablePrepareService,
                    AgTableVirtualScrollService,
                    AgTableCustomSettings,
                    AgTableSettings,
                    AgTableLangService,
                    Helper
                ],
                entryComponents: []
            }),
            core.Injectable()
        ], AgTableModule);
        return AgTableModule;
    }());

    exports.AgTableCustomSettings = AgTableCustomSettings;
    exports.AgTableDataRenderEvent = AgTableDataRenderEvent;
    exports.AgTableEvent = AgTableEvent;
    exports.AgTableModule = AgTableModule;
    exports.AgTableSettingsAbstract = AgTableSettingsAbstract;
    exports.AgTableVirtualScrollModel = AgTableVirtualScrollModel;
    exports.FILTER_TYPES = FILTER_TYPES;
    exports.ɵa = AgTableComponent;
    exports.ɵb = AgTableHeaderComponent;
    exports.ɵc = AgTableColComponent;
    exports.ɵd = Helper;
    exports.ɵe = AgTableLangService;
    exports.ɵf = AgTableSettings;
    exports.ɵg = AgTableBodyComponent;
    exports.ɵh = AgTableRowComponent;
    exports.ɵi = AgTableCellComponent;
    exports.ɵj = AgTableVirtualScrollService;
    exports.ɵk = AgTablePaginateComponent;
    exports.ɵl = AgTablePrepareService;
    exports.ɵm = AgTableFilterComponent;
    exports.ɵn = AgTableSpinnerComponent;
    exports.ɵo = TranslatePipe;
    exports.ɵp = DateFormatDirective;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ag-table.umd.js.map
