import { OnChanges, SimpleChanges } from '@angular/core';
import { Helper } from '../services/helper';
import { AgTableSettings } from '../settings/ag-table.settings';
import { AbstractControl } from '@angular/forms';
export declare class DateFormatDirective implements OnChanges {
    private helper;
    private settings;
    private regex;
    private keyCodesAccepts;
    private datePipe;
    private dateSeparator;
    private ctrlDown;
    private pasting;
    dateFormat: string;
    formControl: AbstractControl;
    constructor(helper: Helper, settings: AgTableSettings);
    ngOnChanges(changes: SimpleChanges): void;
    onKeydown(e: any): boolean;
    onKeyup(e: any): void;
    onPaste(e: any): void;
    onCut(e: any): void;
    onBlur(e: any): void;
    private generateValue;
    maskDate(value: string): void;
}
